package base

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/base/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/base"
)

type ArticleDAO interface {
	//插入Article
	InsertOne(entity *model.Article) error
	//删除指定键的Article
	DeleteOne(artId string) error
	//查找指定键的Article
	SelectOne(artId string) (*model.Article, error)
	//修改Article
	UpdateOne(entity *model.Article) error
	//按条件查询Article
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.Article, error)
	//按条件查询Article并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewArticleDAO(session *xorm.Session, plantNr int, userid string) ArticleDAO {
	return implments.NewArticleDAOImplement(session, plantNr, userid)
}
