package base

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/base/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/base"
)

type CodeParserDAO interface {
	//插入CodeParser
	InsertOne(entity *model.CodeParser) error
	//删除指定键的CodeParser
	DeleteOne(parserId string) error
	//查找指定键的CodeParser
	SelectOne(parserId string) (*model.CodeParser, error)
	//修改CodeParser
	UpdateOne(entity *model.CodeParser) error
	//按条件查询CodeParser
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.CodeParser, error)
	//按条件查询CodeParser并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewCodeParserDAO(session *xorm.Session, plantNr int, userid string) CodeParserDAO {
	return implments.NewCodeParserDAOImplement(session, plantNr, userid)
}
