package base

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/base/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/base"
)

type PlantDAO interface {
	//插入Plant
	InsertOne(entity *model.Plant) error
	//删除指定键的Plant
	DeleteOne() error
	//查找指定键的Plant
	SelectOne() (*model.Plant, error)
	//修改Plant
	UpdateOne(entity *model.Plant) error
	//按条件查询Plant
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.Plant, error)
	//按条件查询Plant并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewPlantDAO(session *xorm.Session, plantNr int, userid string) PlantDAO {
	return implments.NewPlantDAOImplement(session, plantNr, userid)
}
