package base

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/base/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/base"
)

type UomDAO interface {
	//插入Uom
	InsertOne(entity *model.Uom) error
	//删除指定键的Uom
	DeleteOne(uomId string) error
	//查找指定键的Uom
	SelectOne(uomId string) (*model.Uom, error)
	//修改Uom
	UpdateOne(entity *model.Uom) error
	//按条件查询Uom
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.Uom, error)
	//按条件查询Uom并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewUomDAO(session *xorm.Session, plantNr int, userid string) UomDAO {
	return implments.NewUomDAOImplement(session, plantNr, userid)
}
