package base

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/base/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/base"
)

type WeekModelLstDAO interface {
	//插入WeekModelLst
	InsertOne(entity *model.WeekModelLst) error
	//删除指定键的WeekModelLst
	DeleteOne(weekModelNr int, workDate int) error
	//查找指定键的WeekModelLst
	SelectOne(weekModelNr int, workDate int) (*model.WeekModelLst, error)
	//修改WeekModelLst
	UpdateOne(entity *model.WeekModelLst) error
	//按条件查询WeekModelLst
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.WeekModelLst, error)
	//按条件查询WeekModelLst并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewWeekModelLstDAO(session *xorm.Session, plantNr int, userid string) WeekModelLstDAO {
	return implments.NewWeekModelLstDAOImplement(session, plantNr, userid)
}
