package base

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/base/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/base"
)

type WorkCalendarLstDAO interface {
	//插入WorkCalendarLst
	InsertOne(entity *model.WorkCalendarLst) error
	//删除指定键的WorkCalendarLst
	DeleteOne(workCalendarNr int, workDate int) error
	//查找指定键的WorkCalendarLst
	SelectOne(workCalendarNr int, workDate int) (*model.WorkCalendarLst, error)
	//修改WorkCalendarLst
	UpdateOne(entity *model.WorkCalendarLst) error
	//按条件查询WorkCalendarLst
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.WorkCalendarLst, error)
	//按条件查询WorkCalendarLst并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewWorkCalendarLstDAO(session *xorm.Session, plantNr int, userid string) WorkCalendarLstDAO {
	return implments.NewWorkCalendarLstDAOImplement(session, plantNr, userid)
}
