package base

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/base/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/base"
)

type WorkLineSpecialDayDAO interface {
	//插入WorkLineSpecialDay
	InsertOne(entity *model.WorkLineSpecialDay) error
	//删除指定键的WorkLineSpecialDay
	DeleteOne(workLineid string, specialDay string) error
	//查找指定键的WorkLineSpecialDay
	SelectOne(workLineid string, specialDay string) (*model.WorkLineSpecialDay, error)
	//修改WorkLineSpecialDay
	UpdateOne(entity *model.WorkLineSpecialDay) error
	//按条件查询WorkLineSpecialDay
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.WorkLineSpecialDay, error)
	//按条件查询WorkLineSpecialDay并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewWorkLineSpecialDayDAO(session *xorm.Session, plantNr int, userid string) WorkLineSpecialDayDAO {
	return implments.NewWorkLineSpecialDayDAOImplement(session, plantNr, userid)
}
