package implments

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	meta "leit.com/LAPP_GAAS_GFrame/meta/base"
	model "leit.com/LAPP_GAAS_GFrame/models/base"
	"xorm.io/core"
)

type DayModelDAOImplement struct {
	session *xorm.Session
	plantNr int
	userid  string
}

func NewDayModelDAOImplement(session *xorm.Session, plantNr int, userid string) *DayModelDAOImplement {
	return &DayModelDAOImplement{session, plantNr, userid}
}

//插入DayModel
func (self *DayModelDAOImplement) InsertOne(entity *model.DayModel) error {
	_, err := self.session.Table(meta.DayModel.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

//删除指定键的DayModel
func (self *DayModelDAOImplement) DeleteOne(dayModelNr int) error {
	_, err := self.session.Table(meta.DayModel.TableName).ID(core.PK{self.plantNr, dayModelNr}).Delete(meta.DayModel.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

//查找指定键的DayModel
func (self *DayModelDAOImplement) SelectOne(dayModelNr int) (*model.DayModel, error) {
	var data model.DayModel
	ok, err := self.session.Table(meta.DayModel.TableName).ID(core.PK{self.plantNr, dayModelNr}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

//修改DayModel
func (self *DayModelDAOImplement) UpdateOne(entity *model.DayModel) error {
	_, err := self.session.Table(meta.DayModel.TableName).Cols(meta.DayModel_Descr.ColumnName, meta.DayModel_Abrev.ColumnName, meta.DayModel_HexColor.ColumnName, meta.DayModel_S1Toggle.ColumnName, meta.DayModel_S2Toggle.ColumnName, meta.DayModel_S3Toggle.ColumnName, meta.DayModel_WorkShiftToggle.ColumnName, meta.DayModel_S1WorkShiftNr.ColumnName, meta.DayModel_S2WorkShiftNr.ColumnName, meta.DayModel_S3WorkShiftNr.ColumnName, meta.DayModel_S1Beg.ColumnName, meta.DayModel_S1End.ColumnName, meta.DayModel_S1Len.ColumnName, meta.DayModel_S2Beg.ColumnName, meta.DayModel_S2End.ColumnName, meta.DayModel_S2Len.ColumnName, meta.DayModel_S3Beg.ColumnName, meta.DayModel_S3End.ColumnName, meta.DayModel_S3Len.ColumnName, meta.DayModel_DmLen.ColumnName, meta.DayModel_S1B1Beg.ColumnName, meta.DayModel_S1B1End.ColumnName, meta.DayModel_S1B2Beg.ColumnName, meta.DayModel_S1B2End.ColumnName, meta.DayModel_S1B3Beg.ColumnName, meta.DayModel_S1B3End.ColumnName, meta.DayModel_S1B4Beg.ColumnName, meta.DayModel_S1B4End.ColumnName, meta.DayModel_S1B5Beg.ColumnName, meta.DayModel_S1B5End.ColumnName, meta.DayModel_S2B1Beg.ColumnName, meta.DayModel_S2B1End.ColumnName, meta.DayModel_S2B2Beg.ColumnName, meta.DayModel_S2B2End.ColumnName, meta.DayModel_S2B3Beg.ColumnName, meta.DayModel_S2B3End.ColumnName, meta.DayModel_S2B4Beg.ColumnName, meta.DayModel_S2B4End.ColumnName, meta.DayModel_S2B5Beg.ColumnName, meta.DayModel_S2B5End.ColumnName, meta.DayModel_S3B1Beg.ColumnName, meta.DayModel_S3B1End.ColumnName, meta.DayModel_S3B2Beg.ColumnName, meta.DayModel_S3B2End.ColumnName, meta.DayModel_S3B3Beg.ColumnName, meta.DayModel_S3B3End.ColumnName, meta.DayModel_S3B4Beg.ColumnName, meta.DayModel_S3B4End.ColumnName, meta.DayModel_S3B5Beg.ColumnName, meta.DayModel_S3B5End.ColumnName, meta.DayModel_LastUser.ColumnName).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

//批量检查DayModel
func (self *DayModelDAOImplement) checkDayModelRecords(records *[]model.DayModel) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return grmi.NewBusinessError("记录不在范围内!")
		}
	}
	return nil
}

//按条件查询DayModel
func (self *DayModelDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.DayModel, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)

	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]model.DayModel, 0, 10)
	session := self.session.Table(meta.DayModel.TableName).Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr")
	for _, field := range orderByFields {
		session = session.OrderBy(field.ColumnName)
	}
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

//按条件查询DayModel并分页
func (self *DayModelDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)

	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Value)
		}
	}
	orderBy := " order by PlantNr"
	for _, field := range orderByFields {
		orderBy += ", " + field.ColumnName
	}
	count, err := self.session.Table(meta.DayModel.TableName).Where("PlantNr = ? "+where, parameters...).Count(meta.DayModel.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.DayModel, 0, 10)
	err = self.session.Table(meta.DayModel.TableName).SQL("select * from DayModel where PlantNr = ?"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}
