package log

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/log/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/log"
)

type ArtDemandHeadDAO interface {
	//插入ArtDemandHead
	InsertOne(entity *model.ArtDemandHead) error
	//删除指定键的ArtDemandHead
	DeleteOne(artId string, demandId string) error
	//查找指定键的ArtDemandHead
	SelectOne(artId string, demandId string) (*model.ArtDemandHead, error)
	//修改ArtDemandHead
	UpdateOne(entity *model.ArtDemandHead) error
	//按条件查询ArtDemandHead
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ArtDemandHead, error)
	//按条件查询ArtDemandHead并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewArtDemandHeadDAO(session *xorm.Session, plantNr int, userid string) ArtDemandHeadDAO {
	return implments.NewArtDemandHeadDAOImplement(session, plantNr, userid)
}
