package log

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/log/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/log"
)

type PackOrderDAO interface {
	//插入PackOrder
	InsertOne(entity *model.PackOrder) error
	//删除指定键的PackOrder
	DeleteOne(packOrderId string) error
	//查找指定键的PackOrder
	SelectOne(packOrderId string) (*model.PackOrder, error)
	//修改PackOrder
	UpdateOne(entity *model.PackOrder) error
	//按条件查询PackOrder
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.PackOrder, error)
	//按条件查询PackOrder并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewPackOrderDAO(session *xorm.Session, plantNr int, userid string) PackOrderDAO {
	return implments.NewPackOrderDAOImplement(session, plantNr, userid)
}
