package log

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/log/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/log"
)

type PackTemplateDAO interface {
	//插入PackTemplate
	InsertOne(entity *model.PackTemplate) error
	//删除指定键的PackTemplate
	DeleteOne(packTemplateId string) error
	//查找指定键的PackTemplate
	SelectOne(packTemplateId string) (*model.PackTemplate, error)
	//修改PackTemplate
	UpdateOne(entity *model.PackTemplate) error
	//按条件查询PackTemplate
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.PackTemplate, error)
	//按条件查询PackTemplate并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewPackTemplateDAO(session *xorm.Session, plantNr int, userid string) PackTemplateDAO {
	return implments.NewPackTemplateDAOImplement(session, plantNr, userid)
}
