package log

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/log/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/log"
)

type PackTypeDAO interface {
	//插入PackType
	InsertOne(entity *model.PackType) error
	//删除指定键的PackType
	DeleteOne(packTypeId string) error
	//查找指定键的PackType
	SelectOne(packTypeId string) (*model.PackType, error)
	//修改PackType
	UpdateOne(entity *model.PackType) error
	//按条件查询PackType
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.PackType, error)
	//按条件查询PackType并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewPackTypeDAO(session *xorm.Session, plantNr int, userid string) PackTypeDAO {
	return implments.NewPackTypeDAOImplement(session, plantNr, userid)
}
