package log

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/log/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/log"
)

type VendorDAO interface {
	//插入Vendor
	InsertOne(entity *model.Vendor) error
	//删除指定键的Vendor
	DeleteOne(vendorId string) error
	//查找指定键的Vendor
	SelectOne(vendorId string) (*model.Vendor, error)
	//修改Vendor
	UpdateOne(entity *model.Vendor) error
	//按条件查询Vendor
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.Vendor, error)
	//按条件查询Vendor并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewVendorDAO(session *xorm.Session, plantNr int, userid string) VendorDAO {
	return implments.NewVendorDAOImplement(session, plantNr, userid)
}
