package implments

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	meta "leit.com/LAPP_GAAS_GFrame/meta/log"
	model "leit.com/LAPP_GAAS_GFrame/models/log"
	"xorm.io/core"
)

type PackTemplateItemlstDAOImplement struct {
	session *xorm.Session
	plantNr int
	userid  string
}

func NewPackTemplateItemlstDAOImplement(session *xorm.Session, plantNr int, userid string) *PackTemplateItemlstDAOImplement {
	return &PackTemplateItemlstDAOImplement{session, plantNr, userid}
}

//插入PackTemplateItemlst
func (self *PackTemplateItemlstDAOImplement) InsertOne(entity *model.PackTemplateItemlst) error {
	_, err := self.session.Table(meta.PackTemplateItemlst.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

//删除指定键的PackTemplateItemlst
func (self *PackTemplateItemlstDAOImplement) DeleteOne(packTemplateId string, pos int) error {
	_, err := self.session.Table(meta.PackTemplateItemlst.TableName).ID(core.PK{self.plantNr, packTemplateId, pos}).Delete(meta.PackTemplateItemlst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

//查找指定键的PackTemplateItemlst
func (self *PackTemplateItemlstDAOImplement) SelectOne(packTemplateId string, pos int) (*model.PackTemplateItemlst, error) {
	var data model.PackTemplateItemlst
	ok, err := self.session.Table(meta.PackTemplateItemlst.TableName).ID(core.PK{self.plantNr, packTemplateId, pos}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

//修改PackTemplateItemlst
func (self *PackTemplateItemlstDAOImplement) UpdateOne(entity *model.PackTemplateItemlst) error {
	_, err := self.session.Table(meta.PackTemplateItemlst.TableName).Cols(meta.PackTemplateItemlst_PosCode.ColumnName, meta.PackTemplateItemlst_MaterialId.ColumnName, meta.PackTemplateItemlst_Seq.ColumnName, meta.PackTemplateItemlst_PlanQty.ColumnName, meta.PackTemplateItemlst_PKTMPICustC1.ColumnName, meta.PackTemplateItemlst_PKTMPICustC2.ColumnName, meta.PackTemplateItemlst_PKTMPICustI1.ColumnName, meta.PackTemplateItemlst_PKTMPICustI2.ColumnName, meta.PackTemplateItemlst_LastUser.ColumnName).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

//批量检查PackTemplateItemlst
func (self *PackTemplateItemlstDAOImplement) checkPackTemplateItemlstRecords(records *[]model.PackTemplateItemlst) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return grmi.NewBusinessError("记录不在范围内!")
		}
	}
	return nil
}

//按条件查询PackTemplateItemlst
func (self *PackTemplateItemlstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.PackTemplateItemlst, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)

	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]model.PackTemplateItemlst, 0, 10)
	session := self.session.Table(meta.PackTemplateItemlst.TableName).Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr")
	for _, field := range orderByFields {
		session = session.OrderBy(field.ColumnName)
	}
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

//按条件查询PackTemplateItemlst并分页
func (self *PackTemplateItemlstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)

	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Value)
		}
	}
	orderBy := " order by PlantNr"
	for _, field := range orderByFields {
		orderBy += ", " + field.ColumnName
	}
	count, err := self.session.Table(meta.PackTemplateItemlst.TableName).Where("PlantNr = ? "+where, parameters...).Count(meta.PackTemplateItemlst.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.PackTemplateItemlst, 0, 10)
	err = self.session.Table(meta.PackTemplateItemlst.TableName).SQL("select * from LOG_PackTemplateItemlst where PlantNr = ?"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}
