package implments

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	meta "leit.com/LAPP_GAAS_GFrame/meta/log"
	model "leit.com/LAPP_GAAS_GFrame/models/log"
	"xorm.io/core"
)

type PackTemplatePrintlstDAOImplement struct {
	session *xorm.Session
	plantNr int
	userid  string
}

func NewPackTemplatePrintlstDAOImplement(session *xorm.Session, plantNr int, userid string) *PackTemplatePrintlstDAOImplement {
	return &PackTemplatePrintlstDAOImplement{session, plantNr, userid}
}

//插入PackTemplatePrintlst
func (self *PackTemplatePrintlstDAOImplement) InsertOne(entity *model.PackTemplatePrintlst) error {
	_, err := self.session.Table(meta.PackTemplatePrintlst.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

//删除指定键的PackTemplatePrintlst
func (self *PackTemplatePrintlstDAOImplement) DeleteOne(packTemplateId string, pos int) error {
	_, err := self.session.Table(meta.PackTemplatePrintlst.TableName).ID(core.PK{self.plantNr, packTemplateId, pos}).Delete(meta.PackTemplatePrintlst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

//查找指定键的PackTemplatePrintlst
func (self *PackTemplatePrintlstDAOImplement) SelectOne(packTemplateId string, pos int) (*model.PackTemplatePrintlst, error) {
	var data model.PackTemplatePrintlst
	ok, err := self.session.Table(meta.PackTemplatePrintlst.TableName).ID(core.PK{self.plantNr, packTemplateId, pos}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

//修改PackTemplatePrintlst
func (self *PackTemplatePrintlstDAOImplement) UpdateOne(entity *model.PackTemplatePrintlst) error {
	_, err := self.session.Table(meta.PackTemplatePrintlst.TableName).Cols(meta.PackTemplatePrintlst_VarName.ColumnName, meta.PackTemplatePrintlst_VarValue.ColumnName, meta.PackTemplatePrintlst_VarType.ColumnName, meta.PackTemplatePrintlst_VarPos.ColumnName, meta.PackTemplatePrintlst_Picture.ColumnName, meta.PackTemplatePrintlst_IsIdxToggle.ColumnName, meta.PackTemplatePrintlst_KeyVal.ColumnName, meta.PackTemplatePrintlst_LastUser.ColumnName).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

//批量检查PackTemplatePrintlst
func (self *PackTemplatePrintlstDAOImplement) checkPackTemplatePrintlstRecords(records *[]model.PackTemplatePrintlst) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return grmi.NewBusinessError("记录不在范围内!")
		}
	}
	return nil
}

//按条件查询PackTemplatePrintlst
func (self *PackTemplatePrintlstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.PackTemplatePrintlst, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)

	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]model.PackTemplatePrintlst, 0, 10)
	session := self.session.Table(meta.PackTemplatePrintlst.TableName).Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr")
	for _, field := range orderByFields {
		session = session.OrderBy(field.ColumnName)
	}
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

//按条件查询PackTemplatePrintlst并分页
func (self *PackTemplatePrintlstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)

	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Value)
		}
	}
	orderBy := " order by PlantNr"
	for _, field := range orderByFields {
		orderBy += ", " + field.ColumnName
	}
	count, err := self.session.Table(meta.PackTemplatePrintlst.TableName).Where("PlantNr = ? "+where, parameters...).Count(meta.PackTemplatePrintlst.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.PackTemplatePrintlst, 0, 10)
	err = self.session.Table(meta.PackTemplatePrintlst.TableName).SQL("select * from LOG_PackTemplatePrintlst where PlantNr = ?"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}
