package ods

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/ods/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/ods"
)

type OdsTypeDAO interface {
	//插入OdsType
	InsertOne(entity *model.OdsType) error
	//删除指定键的OdsType
	DeleteOne(odsTypeId string) error
	//查找指定键的OdsType
	SelectOne(odsTypeId string) (*model.OdsType, error)
	//修改OdsType
	UpdateOne(entity *model.OdsType) error
	//按条件查询OdsType
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.OdsType, error)
	//按条件查询OdsType并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewOdsTypeDAO(session *xorm.Session, plantNr int, userid string) OdsTypeDAO {
	return implments.NewOdsTypeDAOImplement(session, plantNr, userid)
}
