package implments

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	meta "leit.com/LAPP_GAAS_GFrame/meta/ods"
	model "leit.com/LAPP_GAAS_GFrame/models/ods"
	"xorm.io/core"
)

type ArtRouteStepOdsLstDAOImplement struct {
	session *xorm.Session
	plantNr int
	userid  string
}

func NewArtRouteStepOdsLstDAOImplement(session *xorm.Session, plantNr int, userid string) *ArtRouteStepOdsLstDAOImplement {
	return &ArtRouteStepOdsLstDAOImplement{session, plantNr, userid}
}

//插入ArtRouteStepOdsLst
func (self *ArtRouteStepOdsLstDAOImplement) InsertOne(entity *model.ArtRouteStepOdsLst) error {
	_, err := self.session.Table(meta.ArtRouteStepOdsLst.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

//删除指定键的ArtRouteStepOdsLst
func (self *ArtRouteStepOdsLstDAOImplement) DeleteOne(artId string, operationNr int, step int, pos int) error {
	_, err := self.session.Table(meta.ArtRouteStepOdsLst.TableName).ID(core.PK{self.plantNr, artId, operationNr, step, pos}).Delete(meta.ArtRouteStepOdsLst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

//查找指定键的ArtRouteStepOdsLst
func (self *ArtRouteStepOdsLstDAOImplement) SelectOne(artId string, operationNr int, step int, pos int) (*model.ArtRouteStepOdsLst, error) {
	var data model.ArtRouteStepOdsLst
	ok, err := self.session.Table(meta.ArtRouteStepOdsLst.TableName).ID(core.PK{self.plantNr, artId, operationNr, step, pos}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

//修改ArtRouteStepOdsLst
func (self *ArtRouteStepOdsLstDAOImplement) UpdateOne(entity *model.ArtRouteStepOdsLst) error {
	_, err := self.session.Table(meta.ArtRouteStepOdsLst.TableName).Cols(meta.ArtRouteStepOdsLst_WorkPlaceId.ColumnName, meta.ArtRouteStepOdsLst_Descr.ColumnName, meta.ArtRouteStepOdsLst_OdsId.ColumnName, meta.ArtRouteStepOdsLst_OdsTypeId.ColumnName, meta.ArtRouteStepOdsLst_OdsContentIdx.ColumnName, meta.ArtRouteStepOdsLst_CtrlPara1.ColumnName, meta.ArtRouteStepOdsLst_CtrlPara2.ColumnName, meta.ArtRouteStepOdsLst_CtrlPara3.ColumnName, meta.ArtRouteStepOdsLst_CtrlPara4.ColumnName, meta.ArtRouteStepOdsLst_LastUser.ColumnName).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

//批量检查ArtRouteStepOdsLst
func (self *ArtRouteStepOdsLstDAOImplement) checkArtRouteStepOdsLstRecords(records *[]model.ArtRouteStepOdsLst) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return grmi.NewBusinessError("记录不在范围内!")
		}
	}
	return nil
}

//按条件查询ArtRouteStepOdsLst
func (self *ArtRouteStepOdsLstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ArtRouteStepOdsLst, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)

	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]model.ArtRouteStepOdsLst, 0, 10)
	session := self.session.Table(meta.ArtRouteStepOdsLst.TableName).Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr")
	for _, field := range orderByFields {
		session = session.OrderBy(field.ColumnName)
	}
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

//按条件查询ArtRouteStepOdsLst并分页
func (self *ArtRouteStepOdsLstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)

	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Value)
		}
	}
	orderBy := " order by PlantNr"
	for _, field := range orderByFields {
		orderBy += ", " + field.ColumnName
	}
	count, err := self.session.Table(meta.ArtRouteStepOdsLst.TableName).Where("PlantNr = ? "+where, parameters...).Count(meta.ArtRouteStepOdsLst.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ArtRouteStepOdsLst, 0, 10)
	err = self.session.Table(meta.ArtRouteStepOdsLst.TableName).SQL("select * from ODS_ArtRouteStepOdsLst where PlantNr = ?"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}
