package om

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/om/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/om"
)

type ProdOrderDAO interface {
	//插入ProdOrder
	InsertOne(entity *model.ProdOrder) error
	//删除指定键的ProdOrder
	DeleteOne(prodOrderId string) error
	//查找指定键的ProdOrder
	SelectOne(prodOrderId string) (*model.ProdOrder, error)
	//修改ProdOrder
	UpdateOne(entity *model.ProdOrder) error
	//按条件查询ProdOrder
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ProdOrder, error)
	//按条件查询ProdOrder并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewProdOrderDAO(session *xorm.Session, plantNr int, userid string) ProdOrderDAO {
	return implments.NewProdOrderDAOImplement(session, plantNr, userid)
}
