package om

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/om/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/om"
)

type ProdOrderStatusDAO interface {
	//插入ProdOrderStatus
	InsertOne(entity *model.ProdOrderStatus) error
	//删除指定键的ProdOrderStatus
	DeleteOne(prodOrderId string) error
	//查找指定键的ProdOrderStatus
	SelectOne(prodOrderId string) (*model.ProdOrderStatus, error)
	//修改ProdOrderStatus
	UpdateOne(entity *model.ProdOrderStatus) error
	//按条件查询ProdOrderStatus
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ProdOrderStatus, error)
	//按条件查询ProdOrderStatus并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewProdOrderStatusDAO(session *xorm.Session, plantNr int, userid string) ProdOrderStatusDAO {
	return implments.NewProdOrderStatusDAOImplement(session, plantNr, userid)
}
