package implments

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	meta "leit.com/LAPP_GAAS_GFrame/meta/om"
	model "leit.com/LAPP_GAAS_GFrame/models/om"
	"xorm.io/core"
)

type ProdOrderStatusRecLstDAOImplement struct {
	session *xorm.Session
	plantNr int
	userid  string
}

func NewProdOrderStatusRecLstDAOImplement(session *xorm.Session, plantNr int, userid string) *ProdOrderStatusRecLstDAOImplement {
	return &ProdOrderStatusRecLstDAOImplement{session, plantNr, userid}
}

//插入ProdOrderStatusRecLst
func (self *ProdOrderStatusRecLstDAOImplement) InsertOne(entity *model.ProdOrderStatusRecLst) error {
	_, err := self.session.Table(meta.ProdOrderStatusRecLst.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

//删除指定键的ProdOrderStatusRecLst
func (self *ProdOrderStatusRecLstDAOImplement) DeleteOne(prodOrderId string, pos int) error {
	_, err := self.session.Table(meta.ProdOrderStatusRecLst.TableName).ID(core.PK{self.plantNr, prodOrderId, pos}).Delete(meta.ProdOrderStatusRecLst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

//查找指定键的ProdOrderStatusRecLst
func (self *ProdOrderStatusRecLstDAOImplement) SelectOne(prodOrderId string, pos int) (*model.ProdOrderStatusRecLst, error) {
	var data model.ProdOrderStatusRecLst
	ok, err := self.session.Table(meta.ProdOrderStatusRecLst.TableName).ID(core.PK{self.plantNr, prodOrderId, pos}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

//修改ProdOrderStatusRecLst
func (self *ProdOrderStatusRecLstDAOImplement) UpdateOne(entity *model.ProdOrderStatusRecLst) error {
	_, err := self.session.Table(meta.ProdOrderStatusRecLst.TableName).Cols(meta.ProdOrderStatusRecLst_PrevStatus.ColumnName, meta.ProdOrderStatusRecLst_Status.ColumnName, meta.ProdOrderStatusRecLst_StartTime.ColumnName, meta.ProdOrderStatusRecLst_EndTime.ColumnName, meta.ProdOrderStatusRecLst_TriggerEvent.ColumnName, meta.ProdOrderStatusRecLst_TriggerObjectId.ColumnName, meta.ProdOrderStatusRecLst_TriggerSubObjectId.ColumnName, meta.ProdOrderStatusRecLst_OutputEvent.ColumnName, meta.ProdOrderStatusRecLst_OutputEventMessageId.ColumnName, meta.ProdOrderStatusRecLst_OutputObjectId.ColumnName, meta.ProdOrderStatusRecLst_OutputSubObjectId.ColumnName, meta.ProdOrderStatusRecLst_Remark1.ColumnName, meta.ProdOrderStatusRecLst_Remark2.ColumnName, meta.ProdOrderStatusRecLst_LastUser.ColumnName).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

//批量检查ProdOrderStatusRecLst
func (self *ProdOrderStatusRecLstDAOImplement) checkProdOrderStatusRecLstRecords(records *[]model.ProdOrderStatusRecLst) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return grmi.NewBusinessError("记录不在范围内!")
		}
	}
	return nil
}

//按条件查询ProdOrderStatusRecLst
func (self *ProdOrderStatusRecLstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ProdOrderStatusRecLst, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)

	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]model.ProdOrderStatusRecLst, 0, 10)
	session := self.session.Table(meta.ProdOrderStatusRecLst.TableName).Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr")
	for _, field := range orderByFields {
		session = session.OrderBy(field.ColumnName)
	}
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

//按条件查询ProdOrderStatusRecLst并分页
func (self *ProdOrderStatusRecLstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)

	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Value)
		}
	}
	orderBy := " order by PlantNr"
	for _, field := range orderByFields {
		orderBy += ", " + field.ColumnName
	}
	count, err := self.session.Table(meta.ProdOrderStatusRecLst.TableName).Where("PlantNr = ? "+where, parameters...).Count(meta.ProdOrderStatusRecLst.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ProdOrderStatusRecLst, 0, 10)
	err = self.session.Table(meta.ProdOrderStatusRecLst.TableName).SQL("select * from OM_ProdOrderStatusRecLst where PlantNr = ?"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}
