package qm

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/dao/qm/implments"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	model "leit.com/LAPP_GAAS_GFrame/models/qm"
)

type DefectRecordDAO interface {
	//插入DefectRecord
	InsertOne(entity *model.DefectRecord) error
	//删除指定键的DefectRecord
	DeleteOne(recNr int) error
	//查找指定键的DefectRecord
	SelectOne(recNr int) (*model.DefectRecord, error)
	//修改DefectRecord
	UpdateOne(entity *model.DefectRecord) error
	//按条件查询DefectRecord
	Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.DefectRecord, error)
	//按条件查询DefectRecord并分页
	SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error)
}

func NewDefectRecordDAO(session *xorm.Session, plantNr int, userid string) DefectRecordDAO {
	return implments.NewDefectRecordDAOImplement(session, plantNr, userid)
}
