package implments

import (
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	meta "leit.com/LAPP_GAAS_GFrame/meta/qm"
	model "leit.com/LAPP_GAAS_GFrame/models/qm"
	"xorm.io/core"
)

type ViewDefectGrplstDAOImplement struct {
	session *xorm.Session
	plantNr int
	userid  string
}

func NewViewDefectGrplstDAOImplement(session *xorm.Session, plantNr int, userid string) *ViewDefectGrplstDAOImplement {
	return &ViewDefectGrplstDAOImplement{session, plantNr, userid}
}

//插入ViewDefectGrplst
func (self *ViewDefectGrplstDAOImplement) InsertOne(entity *model.ViewDefectGrplst) error {
	_, err := self.session.Table(meta.ViewDefectGrplst.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

//删除指定键的ViewDefectGrplst
func (self *ViewDefectGrplstDAOImplement) DeleteOne(viewId string, defectGrpId string) error {
	_, err := self.session.Table(meta.ViewDefectGrplst.TableName).ID(core.PK{self.plantNr, viewId, defectGrpId}).Delete(meta.ViewDefectGrplst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

//查找指定键的ViewDefectGrplst
func (self *ViewDefectGrplstDAOImplement) SelectOne(viewId string, defectGrpId string) (*model.ViewDefectGrplst, error) {
	var data model.ViewDefectGrplst
	ok, err := self.session.Table(meta.ViewDefectGrplst.TableName).ID(core.PK{self.plantNr, viewId, defectGrpId}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

//修改ViewDefectGrplst
func (self *ViewDefectGrplstDAOImplement) UpdateOne(entity *model.ViewDefectGrplst) error {
	_, err := self.session.Table(meta.ViewDefectGrplst.TableName).Cols(meta.ViewDefectGrplst_Pos.ColumnName, meta.ViewDefectGrplst_LastUser.ColumnName).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

//批量检查ViewDefectGrplst
func (self *ViewDefectGrplstDAOImplement) checkViewDefectGrplstRecords(records *[]model.ViewDefectGrplst) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return grmi.NewBusinessError("记录不在范围内!")
		}
	}
	return nil
}

//按条件查询ViewDefectGrplst
func (self *ViewDefectGrplstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ViewDefectGrplst, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)

	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]model.ViewDefectGrplst, 0, 10)
	session := self.session.Table(meta.ViewDefectGrplst.TableName).Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr")
	for _, field := range orderByFields {
		session = session.OrderBy(field.ColumnName)
	}
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

//按条件查询ViewDefectGrplst并分页
func (self *ViewDefectGrplstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)

	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Value)
		}
	}
	orderBy := " order by PlantNr"
	for _, field := range orderByFields {
		orderBy += ", " + field.ColumnName
	}
	count, err := self.session.Table(meta.ViewDefectGrplst.TableName).Where("PlantNr = ? "+where, parameters...).Count(meta.ViewDefectGrplst.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ViewDefectGrplst, 0, 10)
	err = self.session.Table(meta.ViewDefectGrplst.TableName).SQL("select * from QM_ViewDefectGrplst where PlantNr = ?"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}
