package base

import (
	"leit.com/LAPP_GAAS_GFrame/grmi"
	"xorm.io/core"
)

//Article的实体映射
type Article struct {
	PlantNr               int           `xorm:"pk int 'PlantNr'" json:"Article-PlantNr"`
	ArtId                 string        `xorm:"pk nvarchar(40) 'ArtId'" json:"Article-ArtId"`
	Descr1                string        `xorm:"nvarchar(100) 'Descr1' not null" json:"Article-Descr1"`
	Descr2                string        `xorm:"nvarchar(100) 'Descr2' not null" json:"Article-Descr2"`
	ArtTypeId             string        `xorm:"nvarchar(40) 'ArtTypeId' not null" json:"Article-ArtTypeId"`
	ProjectId             string        `xorm:"nvarchar(40) 'ProjectId' not null" json:"Article-ProjectId"`
	CustMaterialId        string        `xorm:"nvarchar(40) 'CustMaterialId' not null" json:"Article-CustMaterialId"`
	AlternativeMaterialId string        `xorm:"nvarchar(40) 'AlternativeMaterialId' not null" json:"Article-AlternativeMaterialId"`
	UomId                 string        `xorm:"nvarchar(40) 'UomId' not null" json:"Article-UomId"`
	QuantityPerHour       float64       `xorm:"float 'QuantityPerHour' not null" json:"Article-QuantityPerHour"`
	DeliveryBuffer        float64       `xorm:"float 'DeliveryBuffer'" json:"Article-DeliveryBuffer"`
	Icon                  string        `xorm:"nvarchar(100) 'Icon' not null" json:"Article-Icon"`
	DisplayColor          string        `xorm:"nvarchar(20) 'DisplayColor' not null" json:"Article-DisplayColor"`
	Document              string        `xorm:"nvarchar(100) 'Document' not null" json:"Article-Document"`
	DefaultRoute          string        `xorm:"nvarchar(40) 'DefaultRoute' not null" json:"Article-DefaultRoute"`
	LotSize               float64       `xorm:"float 'LotSize'" json:"Article-LotSize"`
	ABCClass              string        `xorm:"nvarchar(1) 'ABCClass' not null" json:"Article-ABCClass"`
	ArtSize1              string        `xorm:"nvarchar(100) 'ArtSize1' not null" json:"Article-ArtSize1"`
	ArtSize2              string        `xorm:"nvarchar(100) 'ArtSize2' not null" json:"Article-ArtSize2"`
	ArtSize3              string        `xorm:"nvarchar(100) 'ArtSize3' not null" json:"Article-ArtSize3"`
	ArtSize4              string        `xorm:"nvarchar(100) 'ArtSize4' not null" json:"Article-ArtSize4"`
	ArtSize5              string        `xorm:"nvarchar(100) 'ArtSize5' not null" json:"Article-ArtSize5"`
	ArtSpec1              string        `xorm:"nvarchar(100) 'ArtSpec1' not null" json:"Article-ArtSpec1"`
	ArtSpec2              string        `xorm:"nvarchar(100) 'ArtSpec2' not null" json:"Article-ArtSpec2"`
	ArtSpec3              string        `xorm:"nvarchar(100) 'ArtSpec3' not null" json:"Article-ArtSpec3"`
	ArtSpec4              string        `xorm:"nvarchar(100) 'ArtSpec4' not null" json:"Article-ArtSpec4"`
	ArtSpec5              string        `xorm:"nvarchar(100) 'ArtSpec5' not null" json:"Article-ArtSpec5"`
	DefaultInspectPlanId  string        `xorm:"nvarchar(40) 'DefaultInspectPlanId' not null" json:"Article-DefaultInspectPlanId"`
	LastModify            grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"Article-LastModify"`
	LastUser              string        `xorm:"nvarchar(20) 'LastUser' not null" json:"Article-LastUser"`
	CreateTime            grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"Article-CreateTime"`
}

//获取Article的主键
func (self *Article) GetKey() core.PK {
	return core.PK{self.PlantNr, self.ArtId}
}
