package base

import (
	"leit.com/LAPP_GAAS_GFrame/grmi"
	"xorm.io/core"
)

//WorkShift的实体映射
type WorkShift struct {
	PlantNr        int           `xorm:"pk int 'PlantNr'" json:"WorkShift-PlantNr"`
	WorkShiftNr    int           `xorm:"pk int 'WorkShiftNr'" json:"WorkShift-WorkShiftNr"`
	Descr          string        `xorm:"nvarchar(100) 'Descr'" json:"WorkShift-Descr"`
	Abrev          string        `xorm:"nvarchar(10) 'Abrev' not null" json:"WorkShift-Abrev"`
	HexColor       string        `xorm:"nvarchar(10) 'HexColor'" json:"WorkShift-HexColor"`
	PlanPersonQty  int           `xorm:"int 'PlanPersonQty'" json:"WorkShift-PlanPersonQty"`
	PlanEfficiency float64       `xorm:"float 'PlanEfficiency' not null" json:"WorkShift-PlanEfficiency"`
	SBeg           int           `xorm:"int 'S_Beg'" json:"WorkShift-S_Beg"`
	SEnd           int           `xorm:"int 'S_End'" json:"WorkShift-S_End"`
	SLen           int           `xorm:"int 'S_Len'" json:"WorkShift-S_Len"`
	SB1Beg         int           `xorm:"int 'S_B1_Beg'" json:"WorkShift-S_B1_Beg"`
	SB1End         int           `xorm:"int 'S_B1_End'" json:"WorkShift-S_B1_End"`
	SB2Beg         int           `xorm:"int 'S_B2_Beg'" json:"WorkShift-S_B2_Beg"`
	SB2End         int           `xorm:"int 'S_B2_End'" json:"WorkShift-S_B2_End"`
	SB3Beg         int           `xorm:"int 'S_B3_Beg'" json:"WorkShift-S_B3_Beg"`
	SB3End         int           `xorm:"int 'S_B3_End'" json:"WorkShift-S_B3_End"`
	SB4Beg         int           `xorm:"int 'S_B4_Beg'" json:"WorkShift-S_B4_Beg"`
	SB4End         int           `xorm:"int 'S_B4_End'" json:"WorkShift-S_B4_End"`
	SB5Beg         int           `xorm:"int 'S_B5_Beg'" json:"WorkShift-S_B5_Beg"`
	SB5End         int           `xorm:"int 'S_B5_End'" json:"WorkShift-S_B5_End"`
	LastModify     grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"WorkShift-LastModify"`
	LastUser       string        `xorm:"nvarchar(20) 'LastUser' not null" json:"WorkShift-LastUser"`
	CreateTime     grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"WorkShift-CreateTime"`
}

//获取WorkShift的主键
func (self *WorkShift) GetKey() core.PK {
	return core.PK{self.PlantNr, self.WorkShiftNr}
}
