package log

import (
	"leit.com/LAPP_GAAS_GFrame/grmi"
	"xorm.io/core"
)

//PackType的实体映射
type PackType struct {
	PlantNr          int           `xorm:"pk int 'PlantNr'" json:"LOG_PackType-PlantNr"`
	PackTypeId       string        `xorm:"pk nvarchar(40) 'PackTypeId'" json:"LOG_PackType-PackTypeId"`
	Descr            string        `xorm:"nvarchar(100) 'Descr' not null" json:"LOG_PackType-Descr"`
	SortWay          string        `xorm:"nvarchar(10) 'SortWay' not null" json:"LOG_PackType-SortWay"`
	VerifySlotToggle bool          `xorm:"bit 'VerifySlotToggle' not null" json:"LOG_PackType-VerifySlotToggle"`
	VerifyRule       string        `xorm:"nvarchar(100) 'VerifyRule' not null" json:"LOG_PackType-VerifyRule"`
	Length           float64       `xorm:"float 'Length' not null" json:"LOG_PackType-Length"`
	Width            float64       `xorm:"float 'Width' not null" json:"LOG_PackType-Width"`
	Height           float64       `xorm:"float 'Height' not null" json:"LOG_PackType-Height"`
	SizeUom          string        `xorm:"nvarchar(10) 'SizeUom' not null" json:"LOG_PackType-SizeUom"`
	Weight           float64       `xorm:"float 'Weight' not null" json:"LOG_PackType-Weight"`
	WeightUom        string        `xorm:"nvarchar(10) 'WeightUom' not null" json:"LOG_PackType-WeightUom"`
	LastModify       grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"LOG_PackType-LastModify"`
	LastUser         string        `xorm:"nvarchar(20) 'LastUser' not null" json:"LOG_PackType-LastUser"`
	CreateTime       grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"LOG_PackType-CreateTime"`
}

//获取PackType的主键
func (self *PackType) GetKey() core.PK {
	return core.PK{self.PlantNr, self.PackTypeId}
}
