package qm

import (
	"leit.com/LAPP_GAAS_GFrame/grmi"
	"xorm.io/core"
)

//View的实体映射
type View struct {
	PlantNr     int           `xorm:"pk int 'PlantNr'" json:"QM_View-PlantNr"`
	ViewId      string        `xorm:"pk nvarchar(20) 'ViewId'" json:"QM_View-ViewId"`
	Descr       string        `xorm:"nvarchar(100) 'Descr' not null" json:"QM_View-Descr"`
	Picture     string        `xorm:"nvarchar(1000) 'Picture' not null" json:"QM_View-Picture"`
	Abrev       string        `xorm:"nvarchar(20) 'Abrev' not null" json:"QM_View-Abrev"`
	Width       int           `xorm:"int 'Width' not null" json:"QM_View-Width"`
	Height      int           `xorm:"int 'Height' not null" json:"QM_View-Height"`
	XLineColor  string        `xorm:"nvarchar(20) 'XLineColor' not null" json:"QM_View-XLineColor"`
	YLineColor  string        `xorm:"nvarchar(20) 'YLineColor' not null" json:"QM_View-YLineColor"`
	UseXYToggle bool          `xorm:"bit 'UseXYToggle' not null" json:"QM_View-UseXYToggle"`
	LastModify  grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"QM_View-LastModify"`
	LastUser    string        `xorm:"nvarchar(20) 'LastUser' not null" json:"QM_View-LastUser"`
	CreateTime  grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"QM_View-CreateTime"`
}

//获取View的主键
func (self *View) GetKey() core.PK {
	return core.PK{self.PlantNr, self.ViewId}
}
