package implments

import (
	dal "leit.com/LAPP_GAAS_GFrame/dao/base"
	"leit.com/LAPP_GAAS_GFrame/db"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	meta "leit.com/LAPP_GAAS_GFrame/meta/base"
	model "leit.com/LAPP_GAAS_GFrame/models/base"
	"leit.com/LAPP_GAAS_GFrame/web/models"
)

//DayModel的默认查询条件
var DefaultConditionOfDayModel = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.DayModel_DayModelNr.UrlParameterName:      grmi.NewConditionItem(meta.DayModel_DayModelNr, grmi.Equal, true),
		meta.DayModel_Descr.UrlParameterName:           grmi.NewConditionItem(meta.DayModel_Descr, grmi.Equal, false),
		meta.DayModel_Abrev.UrlParameterName:           grmi.NewConditionItem(meta.DayModel_Abrev, grmi.Equal, false),
		meta.DayModel_HexColor.UrlParameterName:        grmi.NewConditionItem(meta.DayModel_HexColor, grmi.Equal, false),
		meta.DayModel_S1Toggle.UrlParameterName:        grmi.NewConditionItem(meta.DayModel_S1Toggle, grmi.Equal, false),
		meta.DayModel_S2Toggle.UrlParameterName:        grmi.NewConditionItem(meta.DayModel_S2Toggle, grmi.Equal, false),
		meta.DayModel_S3Toggle.UrlParameterName:        grmi.NewConditionItem(meta.DayModel_S3Toggle, grmi.Equal, false),
		meta.DayModel_WorkShiftToggle.UrlParameterName: grmi.NewConditionItem(meta.DayModel_WorkShiftToggle, grmi.Equal, false),
		meta.DayModel_S1WorkShiftNr.UrlParameterName:   grmi.NewConditionItem(meta.DayModel_S1WorkShiftNr, grmi.Equal, false),
		meta.DayModel_S2WorkShiftNr.UrlParameterName:   grmi.NewConditionItem(meta.DayModel_S2WorkShiftNr, grmi.Equal, false),
		meta.DayModel_S3WorkShiftNr.UrlParameterName:   grmi.NewConditionItem(meta.DayModel_S3WorkShiftNr, grmi.Equal, false),
		meta.DayModel_S1Beg.UrlParameterName:           grmi.NewConditionItem(meta.DayModel_S1Beg, grmi.Equal, false),
		meta.DayModel_S1End.UrlParameterName:           grmi.NewConditionItem(meta.DayModel_S1End, grmi.Equal, false),
		meta.DayModel_S1Len.UrlParameterName:           grmi.NewConditionItem(meta.DayModel_S1Len, grmi.Equal, false),
		meta.DayModel_S2Beg.UrlParameterName:           grmi.NewConditionItem(meta.DayModel_S2Beg, grmi.Equal, false),
		meta.DayModel_S2End.UrlParameterName:           grmi.NewConditionItem(meta.DayModel_S2End, grmi.Equal, false),
		meta.DayModel_S2Len.UrlParameterName:           grmi.NewConditionItem(meta.DayModel_S2Len, grmi.Equal, false),
		meta.DayModel_S3Beg.UrlParameterName:           grmi.NewConditionItem(meta.DayModel_S3Beg, grmi.Equal, false),
		meta.DayModel_S3End.UrlParameterName:           grmi.NewConditionItem(meta.DayModel_S3End, grmi.Equal, false),
		meta.DayModel_S3Len.UrlParameterName:           grmi.NewConditionItem(meta.DayModel_S3Len, grmi.Equal, false),
		meta.DayModel_DmLen.UrlParameterName:           grmi.NewConditionItem(meta.DayModel_DmLen, grmi.Equal, false),
		meta.DayModel_S1B1Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S1B1Beg, grmi.Equal, false),
		meta.DayModel_S1B1End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S1B1End, grmi.Equal, false),
		meta.DayModel_S1B2Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S1B2Beg, grmi.Equal, false),
		meta.DayModel_S1B2End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S1B2End, grmi.Equal, false),
		meta.DayModel_S1B3Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S1B3Beg, grmi.Equal, false),
		meta.DayModel_S1B3End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S1B3End, grmi.Equal, false),
		meta.DayModel_S1B4Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S1B4Beg, grmi.Equal, false),
		meta.DayModel_S1B4End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S1B4End, grmi.Equal, false),
		meta.DayModel_S1B5Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S1B5Beg, grmi.Equal, false),
		meta.DayModel_S1B5End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S1B5End, grmi.Equal, false),
		meta.DayModel_S2B1Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S2B1Beg, grmi.Equal, false),
		meta.DayModel_S2B1End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S2B1End, grmi.Equal, false),
		meta.DayModel_S2B2Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S2B2Beg, grmi.Equal, false),
		meta.DayModel_S2B2End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S2B2End, grmi.Equal, false),
		meta.DayModel_S2B3Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S2B3Beg, grmi.Equal, false),
		meta.DayModel_S2B3End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S2B3End, grmi.Equal, false),
		meta.DayModel_S2B4Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S2B4Beg, grmi.Equal, false),
		meta.DayModel_S2B4End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S2B4End, grmi.Equal, false),
		meta.DayModel_S2B5Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S2B5Beg, grmi.Equal, false),
		meta.DayModel_S2B5End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S2B5End, grmi.Equal, false),
		meta.DayModel_S3B1Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S3B1Beg, grmi.Equal, false),
		meta.DayModel_S3B1End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S3B1End, grmi.Equal, false),
		meta.DayModel_S3B2Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S3B2Beg, grmi.Equal, false),
		meta.DayModel_S3B2End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S3B2End, grmi.Equal, false),
		meta.DayModel_S3B3Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S3B3Beg, grmi.Equal, false),
		meta.DayModel_S3B3End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S3B3End, grmi.Equal, false),
		meta.DayModel_S3B4Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S3B4Beg, grmi.Equal, false),
		meta.DayModel_S3B4End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S3B4End, grmi.Equal, false),
		meta.DayModel_S3B5Beg.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S3B5Beg, grmi.Equal, false),
		meta.DayModel_S3B5End.UrlParameterName:         grmi.NewConditionItem(meta.DayModel_S3B5End, grmi.Equal, false),
		meta.DayModel_LastModify.UrlParameterName:      grmi.NewConditionItem(meta.DayModel_LastModify, grmi.Approximate, false),
		meta.DayModel_LastUser.UrlParameterName:        grmi.NewConditionItem(meta.DayModel_LastUser, grmi.Equal, false),
		meta.DayModel_CreateTime.UrlParameterName:      grmi.NewConditionItem(meta.DayModel_CreateTime, grmi.Approximate, false),
	},
	nil,
)

//DayModel的默认分页查询条件
var DefaultConditionOfDayModelAndPaging = grmi.NewCondition(
	DefaultConditionOfDayModel.Items,
	grmi.NewPaging(),
)

type DayModelServiceImplement struct {
}

func (self *DayModelServiceImplement) Select(urlParameters map[string]string, user *models.Usertab) (interface{}, error) {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/base/implments/DayModel.service.impl.go", "SelectDayModel", "查询DayModel")

	condition := DefaultConditionOfDayModelAndPaging
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	predicates, err := condition.BuildPredicates(urlParameters)
	if err != nil {
		return nil, err
	}
	dao := dal.NewDayModelDAO(session, user.Pid, user.Userid)
	if condition.Fill(urlParameters) {
		result, err := dao.SelectAndPaging(condition.Paging, predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	} else {
		result, err := dao.Select(predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	}
}

func (self *DayModelServiceImplement) InsertOne(user *models.Usertab, entity *model.DayModel) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/base/implments/DayModel.service.impl.go", "InsertOneDayModel", "插入一个DayModel")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewDayModelDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.DayModelNr)
	if err != nil {
		return err
	}
	if record != nil {
		return grmi.NewBusinessError("已经存在相同主键的记录!")
	}
	err = dao.InsertOne(entity)
	if err != nil {
		return err
	}
	return nil
}

func (self *DayModelServiceImplement) DeleteOne(user *models.Usertab, dayModelNr int) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/base/implments/DayModel.service.impl.go", "DeleteOneDayModel", "删除一个DayModel")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewDayModelDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(dayModelNr)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.DeleteOne(dayModelNr)
	if err != nil {
		return err
	}
	return nil
}

func (self *DayModelServiceImplement) SelectOne(user *models.Usertab, dayModelNr int) (*model.DayModel, error) {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/base/implments/DayModel.service.impl.go", "SelectOneDayModel", "查询一个DayModel")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewDayModelDAO(session, user.Pid, user.Userid)
	result, err := dao.SelectOne(dayModelNr)
	if err != nil {
		return nil, err
	}
	return result, nil
}

func (self *DayModelServiceImplement) UpdateOne(user *models.Usertab, entity *model.DayModel) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/base/implments/DayModel.service.impl.go", "UpdateOneDayModel", "修改一个DayModel")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewDayModelDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.DayModelNr)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.UpdateOne(entity)
	if err != nil {
		return err
	}
	return nil
}

func NewDayModelServiceImplement() *DayModelServiceImplement {
	return &DayModelServiceImplement{}
}
