package implments

import (
	dal "leit.com/LAPP_GAAS_GFrame/dao/log"
	"leit.com/LAPP_GAAS_GFrame/db"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	meta "leit.com/LAPP_GAAS_GFrame/meta/log"
	model "leit.com/LAPP_GAAS_GFrame/models/log"
	"leit.com/LAPP_GAAS_GFrame/web/models"
)

//ArtDemandHead的默认查询条件
var DefaultConditionOfArtDemandHead = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.ArtDemandHead_ArtId.UrlParameterName:              grmi.NewConditionItem(meta.ArtDemandHead_ArtId, grmi.Equal, true),
		meta.ArtDemandHead_DemandId.UrlParameterName:           grmi.NewConditionItem(meta.ArtDemandHead_DemandId, grmi.Equal, true),
		meta.ArtDemandHead_DemandType.UrlParameterName:         grmi.NewConditionItem(meta.ArtDemandHead_DemandType, grmi.Equal, false),
		meta.ArtDemandHead_DemandYear.UrlParameterName:         grmi.NewConditionItem(meta.ArtDemandHead_DemandYear, grmi.Equal, false),
		meta.ArtDemandHead_DemandMonth.UrlParameterName:        grmi.NewConditionItem(meta.ArtDemandHead_DemandMonth, grmi.Equal, false),
		meta.ArtDemandHead_DemandWeek.UrlParameterName:         grmi.NewConditionItem(meta.ArtDemandHead_DemandWeek, grmi.Equal, false),
		meta.ArtDemandHead_DemandDate.UrlParameterName:         grmi.NewConditionItem(meta.ArtDemandHead_DemandDate, grmi.Approximate, false),
		meta.ArtDemandHead_DemandHour.UrlParameterName:         grmi.NewConditionItem(meta.ArtDemandHead_DemandHour, grmi.Equal, false),
		meta.ArtDemandHead_DemandTime.UrlParameterName:         grmi.NewConditionItem(meta.ArtDemandHead_DemandTime, grmi.Approximate, false),
		meta.ArtDemandHead_DemandQty.UrlParameterName:          grmi.NewConditionItem(meta.ArtDemandHead_DemandQty, grmi.Equal, false),
		meta.ArtDemandHead_QtyUomId.UrlParameterName:           grmi.NewConditionItem(meta.ArtDemandHead_QtyUomId, grmi.Equal, false),
		meta.ArtDemandHead_Status.UrlParameterName:             grmi.NewConditionItem(meta.ArtDemandHead_Status, grmi.Equal, false),
		meta.ArtDemandHead_DemandSendTime.UrlParameterName:     grmi.NewConditionItem(meta.ArtDemandHead_DemandSendTime, grmi.Approximate, false),
		meta.ArtDemandHead_DemandRecieveTime.UrlParameterName:  grmi.NewConditionItem(meta.ArtDemandHead_DemandRecieveTime, grmi.Approximate, false),
		meta.ArtDemandHead_DemandConfirmTime.UrlParameterName:  grmi.NewConditionItem(meta.ArtDemandHead_DemandConfirmTime, grmi.Approximate, false),
		meta.ArtDemandHead_DemandCloseTime.UrlParameterName:    grmi.NewConditionItem(meta.ArtDemandHead_DemandCloseTime, grmi.Approximate, false),
		meta.ArtDemandHead_DemandDeliveredQty.UrlParameterName: grmi.NewConditionItem(meta.ArtDemandHead_DemandDeliveredQty, grmi.Equal, false),
		meta.ArtDemandHead_DemandCtrlPara1.UrlParameterName:    grmi.NewConditionItem(meta.ArtDemandHead_DemandCtrlPara1, grmi.Equal, false),
		meta.ArtDemandHead_DemandCtrlPara2.UrlParameterName:    grmi.NewConditionItem(meta.ArtDemandHead_DemandCtrlPara2, grmi.Equal, false),
		meta.ArtDemandHead_DemandCtrlPara3.UrlParameterName:    grmi.NewConditionItem(meta.ArtDemandHead_DemandCtrlPara3, grmi.Equal, false),
		meta.ArtDemandHead_DemandCtrlPara4.UrlParameterName:    grmi.NewConditionItem(meta.ArtDemandHead_DemandCtrlPara4, grmi.Equal, false),
		meta.ArtDemandHead_DemandCtrlTime1.UrlParameterName:    grmi.NewConditionItem(meta.ArtDemandHead_DemandCtrlTime1, grmi.Approximate, false),
		meta.ArtDemandHead_DemandCtrlTime2.UrlParameterName:    grmi.NewConditionItem(meta.ArtDemandHead_DemandCtrlTime2, grmi.Approximate, false),
		meta.ArtDemandHead_LastModify.UrlParameterName:         grmi.NewConditionItem(meta.ArtDemandHead_LastModify, grmi.Approximate, false),
		meta.ArtDemandHead_LastUser.UrlParameterName:           grmi.NewConditionItem(meta.ArtDemandHead_LastUser, grmi.Equal, false),
		meta.ArtDemandHead_CreateTime.UrlParameterName:         grmi.NewConditionItem(meta.ArtDemandHead_CreateTime, grmi.Approximate, false),
	},
	nil,
)

//ArtDemandHead的默认分页查询条件
var DefaultConditionOfArtDemandHeadAndPaging = grmi.NewCondition(
	DefaultConditionOfArtDemandHead.Items,
	grmi.NewPaging(),
)

type ArtDemandHeadServiceImplement struct {
}

func (self *ArtDemandHeadServiceImplement) Select(urlParameters map[string]string, user *models.Usertab) (interface{}, error) {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/log/implments/LOG_ArtDemandHead.service.impl.go", "SelectArtDemandHead", "查询ArtDemandHead")

	condition := DefaultConditionOfArtDemandHeadAndPaging
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	predicates, err := condition.BuildPredicates(urlParameters)
	if err != nil {
		return nil, err
	}
	dao := dal.NewArtDemandHeadDAO(session, user.Pid, user.Userid)
	if condition.Fill(urlParameters) {
		result, err := dao.SelectAndPaging(condition.Paging, predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	} else {
		result, err := dao.Select(predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	}
}

func (self *ArtDemandHeadServiceImplement) InsertOne(user *models.Usertab, entity *model.ArtDemandHead) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/log/implments/LOG_ArtDemandHead.service.impl.go", "InsertOneArtDemandHead", "插入一个ArtDemandHead")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewArtDemandHeadDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.ArtId, entity.DemandId)
	if err != nil {
		return err
	}
	if record != nil {
		return grmi.NewBusinessError("已经存在相同主键的记录!")
	}
	err = dao.InsertOne(entity)
	if err != nil {
		return err
	}
	return nil
}

func (self *ArtDemandHeadServiceImplement) DeleteOne(user *models.Usertab, artId string, demandId string) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/log/implments/LOG_ArtDemandHead.service.impl.go", "DeleteOneArtDemandHead", "删除一个ArtDemandHead")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewArtDemandHeadDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(artId, demandId)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.DeleteOne(artId, demandId)
	if err != nil {
		return err
	}
	return nil
}

func (self *ArtDemandHeadServiceImplement) SelectOne(user *models.Usertab, artId string, demandId string) (*model.ArtDemandHead, error) {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/log/implments/LOG_ArtDemandHead.service.impl.go", "SelectOneArtDemandHead", "查询一个ArtDemandHead")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewArtDemandHeadDAO(session, user.Pid, user.Userid)
	result, err := dao.SelectOne(artId, demandId)
	if err != nil {
		return nil, err
	}
	return result, nil
}

func (self *ArtDemandHeadServiceImplement) UpdateOne(user *models.Usertab, entity *model.ArtDemandHead) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/log/implments/LOG_ArtDemandHead.service.impl.go", "UpdateOneArtDemandHead", "修改一个ArtDemandHead")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewArtDemandHeadDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.ArtId, entity.DemandId)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.UpdateOne(entity)
	if err != nil {
		return err
	}
	return nil
}

func NewArtDemandHeadServiceImplement() *ArtDemandHeadServiceImplement {
	return &ArtDemandHeadServiceImplement{}
}
