package implments

import (
	dal "leit.com/LAPP_GAAS_GFrame/dao/log"
	"leit.com/LAPP_GAAS_GFrame/db"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	meta "leit.com/LAPP_GAAS_GFrame/meta/log"
	model "leit.com/LAPP_GAAS_GFrame/models/log"
	"leit.com/LAPP_GAAS_GFrame/web/models"
)

//PackTemplateItemlst的默认查询条件
var DefaultConditionOfPackTemplateItemlst = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.PackTemplateItemlst_PackTemplateId.UrlParameterName: grmi.NewConditionItem(meta.PackTemplateItemlst_PackTemplateId, grmi.Equal, true),
		meta.PackTemplateItemlst_Pos.UrlParameterName:            grmi.NewConditionItem(meta.PackTemplateItemlst_Pos, grmi.Equal, true),
		meta.PackTemplateItemlst_PosCode.UrlParameterName:        grmi.NewConditionItem(meta.PackTemplateItemlst_PosCode, grmi.Equal, false),
		meta.PackTemplateItemlst_MaterialId.UrlParameterName:     grmi.NewConditionItem(meta.PackTemplateItemlst_MaterialId, grmi.Equal, false),
		meta.PackTemplateItemlst_Seq.UrlParameterName:            grmi.NewConditionItem(meta.PackTemplateItemlst_Seq, grmi.Equal, false),
		meta.PackTemplateItemlst_PlanQty.UrlParameterName:        grmi.NewConditionItem(meta.PackTemplateItemlst_PlanQty, grmi.Equal, false),
		meta.PackTemplateItemlst_PKTMPICustC1.UrlParameterName:   grmi.NewConditionItem(meta.PackTemplateItemlst_PKTMPICustC1, grmi.Equal, false),
		meta.PackTemplateItemlst_PKTMPICustC2.UrlParameterName:   grmi.NewConditionItem(meta.PackTemplateItemlst_PKTMPICustC2, grmi.Equal, false),
		meta.PackTemplateItemlst_PKTMPICustI1.UrlParameterName:   grmi.NewConditionItem(meta.PackTemplateItemlst_PKTMPICustI1, grmi.Equal, false),
		meta.PackTemplateItemlst_PKTMPICustI2.UrlParameterName:   grmi.NewConditionItem(meta.PackTemplateItemlst_PKTMPICustI2, grmi.Equal, false),
		meta.PackTemplateItemlst_LastModify.UrlParameterName:     grmi.NewConditionItem(meta.PackTemplateItemlst_LastModify, grmi.Approximate, false),
		meta.PackTemplateItemlst_LastUser.UrlParameterName:       grmi.NewConditionItem(meta.PackTemplateItemlst_LastUser, grmi.Equal, false),
		meta.PackTemplateItemlst_CreateTime.UrlParameterName:     grmi.NewConditionItem(meta.PackTemplateItemlst_CreateTime, grmi.Approximate, false),
	},
	nil,
)

//PackTemplateItemlst的默认分页查询条件
var DefaultConditionOfPackTemplateItemlstAndPaging = grmi.NewCondition(
	DefaultConditionOfPackTemplateItemlst.Items,
	grmi.NewPaging(),
)

type PackTemplateItemlstServiceImplement struct {
}

func (self *PackTemplateItemlstServiceImplement) Select(urlParameters map[string]string, user *models.Usertab) (interface{}, error) {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "SelectPackTemplateItemlst", "查询PackTemplateItemlst")

	condition := DefaultConditionOfPackTemplateItemlstAndPaging
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	predicates, err := condition.BuildPredicates(urlParameters)
	if err != nil {
		return nil, err
	}
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)
	if condition.Fill(urlParameters) {
		result, err := dao.SelectAndPaging(condition.Paging, predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	} else {
		result, err := dao.Select(predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	}
}

func (self *PackTemplateItemlstServiceImplement) InsertOne(user *models.Usertab, entity *model.PackTemplateItemlst) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "InsertOnePackTemplateItemlst", "插入一个PackTemplateItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.PackTemplateId, entity.Pos)
	if err != nil {
		return err
	}
	if record != nil {
		return grmi.NewBusinessError("已经存在相同主键的记录!")
	}
	err = dao.InsertOne(entity)
	if err != nil {
		return err
	}
	return nil
}

func (self *PackTemplateItemlstServiceImplement) DeleteOne(user *models.Usertab, packTemplateId string, pos int) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "DeleteOnePackTemplateItemlst", "删除一个PackTemplateItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(packTemplateId, pos)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.DeleteOne(packTemplateId, pos)
	if err != nil {
		return err
	}
	return nil
}

func (self *PackTemplateItemlstServiceImplement) SelectOne(user *models.Usertab, packTemplateId string, pos int) (*model.PackTemplateItemlst, error) {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "SelectOnePackTemplateItemlst", "查询一个PackTemplateItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)
	result, err := dao.SelectOne(packTemplateId, pos)
	if err != nil {
		return nil, err
	}
	return result, nil
}

func (self *PackTemplateItemlstServiceImplement) UpdateOne(user *models.Usertab, entity *model.PackTemplateItemlst) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "UpdateOnePackTemplateItemlst", "修改一个PackTemplateItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.PackTemplateId, entity.Pos)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.UpdateOne(entity)
	if err != nil {
		return err
	}
	return nil
}

func NewPackTemplateItemlstServiceImplement() *PackTemplateItemlstServiceImplement {
	return &PackTemplateItemlstServiceImplement{}
}
