package implments

import (
	dal "leit.com/LAPP_GAAS_GFrame/dao/ods"
	"leit.com/LAPP_GAAS_GFrame/db"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	meta "leit.com/LAPP_GAAS_GFrame/meta/ods"
	model "leit.com/LAPP_GAAS_GFrame/models/ods"
	"leit.com/LAPP_GAAS_GFrame/web/models"
)

//ArtRouteStepOdsLst的默认查询条件
var DefaultConditionOfArtRouteStepOdsLst = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.ArtRouteStepOdsLst_ArtId.UrlParameterName:         grmi.NewConditionItem(meta.ArtRouteStepOdsLst_ArtId, grmi.Equal, true),
		meta.ArtRouteStepOdsLst_OperationNr.UrlParameterName:   grmi.NewConditionItem(meta.ArtRouteStepOdsLst_OperationNr, grmi.Equal, true),
		meta.ArtRouteStepOdsLst_Step.UrlParameterName:          grmi.NewConditionItem(meta.ArtRouteStepOdsLst_Step, grmi.Equal, true),
		meta.ArtRouteStepOdsLst_Pos.UrlParameterName:           grmi.NewConditionItem(meta.ArtRouteStepOdsLst_Pos, grmi.Equal, true),
		meta.ArtRouteStepOdsLst_WorkPlaceId.UrlParameterName:   grmi.NewConditionItem(meta.ArtRouteStepOdsLst_WorkPlaceId, grmi.Equal, false),
		meta.ArtRouteStepOdsLst_Descr.UrlParameterName:         grmi.NewConditionItem(meta.ArtRouteStepOdsLst_Descr, grmi.Equal, false),
		meta.ArtRouteStepOdsLst_OdsId.UrlParameterName:         grmi.NewConditionItem(meta.ArtRouteStepOdsLst_OdsId, grmi.Equal, false),
		meta.ArtRouteStepOdsLst_OdsTypeId.UrlParameterName:     grmi.NewConditionItem(meta.ArtRouteStepOdsLst_OdsTypeId, grmi.Equal, false),
		meta.ArtRouteStepOdsLst_OdsContentIdx.UrlParameterName: grmi.NewConditionItem(meta.ArtRouteStepOdsLst_OdsContentIdx, grmi.Equal, false),
		meta.ArtRouteStepOdsLst_CtrlPara1.UrlParameterName:     grmi.NewConditionItem(meta.ArtRouteStepOdsLst_CtrlPara1, grmi.Equal, false),
		meta.ArtRouteStepOdsLst_CtrlPara2.UrlParameterName:     grmi.NewConditionItem(meta.ArtRouteStepOdsLst_CtrlPara2, grmi.Equal, false),
		meta.ArtRouteStepOdsLst_CtrlPara3.UrlParameterName:     grmi.NewConditionItem(meta.ArtRouteStepOdsLst_CtrlPara3, grmi.Equal, false),
		meta.ArtRouteStepOdsLst_CtrlPara4.UrlParameterName:     grmi.NewConditionItem(meta.ArtRouteStepOdsLst_CtrlPara4, grmi.Equal, false),
		meta.ArtRouteStepOdsLst_LastModify.UrlParameterName:    grmi.NewConditionItem(meta.ArtRouteStepOdsLst_LastModify, grmi.Approximate, false),
		meta.ArtRouteStepOdsLst_LastUser.UrlParameterName:      grmi.NewConditionItem(meta.ArtRouteStepOdsLst_LastUser, grmi.Equal, false),
		meta.ArtRouteStepOdsLst_CreateTime.UrlParameterName:    grmi.NewConditionItem(meta.ArtRouteStepOdsLst_CreateTime, grmi.Approximate, false),
	},
	nil,
)

//ArtRouteStepOdsLst的默认分页查询条件
var DefaultConditionOfArtRouteStepOdsLstAndPaging = grmi.NewCondition(
	DefaultConditionOfArtRouteStepOdsLst.Items,
	grmi.NewPaging(),
)

type ArtRouteStepOdsLstServiceImplement struct {
}

func (self *ArtRouteStepOdsLstServiceImplement) Select(urlParameters map[string]string, user *models.Usertab) (interface{}, error) {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/ods/implments/ODS_ArtRouteStepOdsLst.service.impl.go", "SelectArtRouteStepOdsLst", "查询ArtRouteStepOdsLst")

	condition := DefaultConditionOfArtRouteStepOdsLstAndPaging
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	predicates, err := condition.BuildPredicates(urlParameters)
	if err != nil {
		return nil, err
	}
	dao := dal.NewArtRouteStepOdsLstDAO(session, user.Pid, user.Userid)
	if condition.Fill(urlParameters) {
		result, err := dao.SelectAndPaging(condition.Paging, predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	} else {
		result, err := dao.Select(predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	}
}

func (self *ArtRouteStepOdsLstServiceImplement) InsertOne(user *models.Usertab, entity *model.ArtRouteStepOdsLst) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/ods/implments/ODS_ArtRouteStepOdsLst.service.impl.go", "InsertOneArtRouteStepOdsLst", "插入一个ArtRouteStepOdsLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewArtRouteStepOdsLstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.ArtId, entity.OperationNr, entity.Step, entity.Pos)
	if err != nil {
		return err
	}
	if record != nil {
		return grmi.NewBusinessError("已经存在相同主键的记录!")
	}
	err = dao.InsertOne(entity)
	if err != nil {
		return err
	}
	return nil
}

func (self *ArtRouteStepOdsLstServiceImplement) DeleteOne(user *models.Usertab, artId string, operationNr int, step int, pos int) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/ods/implments/ODS_ArtRouteStepOdsLst.service.impl.go", "DeleteOneArtRouteStepOdsLst", "删除一个ArtRouteStepOdsLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewArtRouteStepOdsLstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(artId, operationNr, step, pos)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.DeleteOne(artId, operationNr, step, pos)
	if err != nil {
		return err
	}
	return nil
}

func (self *ArtRouteStepOdsLstServiceImplement) SelectOne(user *models.Usertab, artId string, operationNr int, step int, pos int) (*model.ArtRouteStepOdsLst, error) {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/ods/implments/ODS_ArtRouteStepOdsLst.service.impl.go", "SelectOneArtRouteStepOdsLst", "查询一个ArtRouteStepOdsLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewArtRouteStepOdsLstDAO(session, user.Pid, user.Userid)
	result, err := dao.SelectOne(artId, operationNr, step, pos)
	if err != nil {
		return nil, err
	}
	return result, nil
}

func (self *ArtRouteStepOdsLstServiceImplement) UpdateOne(user *models.Usertab, entity *model.ArtRouteStepOdsLst) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/ods/implments/ODS_ArtRouteStepOdsLst.service.impl.go", "UpdateOneArtRouteStepOdsLst", "修改一个ArtRouteStepOdsLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewArtRouteStepOdsLstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.ArtId, entity.OperationNr, entity.Step, entity.Pos)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.UpdateOne(entity)
	if err != nil {
		return err
	}
	return nil
}

func NewArtRouteStepOdsLstServiceImplement() *ArtRouteStepOdsLstServiceImplement {
	return &ArtRouteStepOdsLstServiceImplement{}
}
