package implments

import (
	dal "leit.com/LAPP_GAAS_GFrame/dao/om"
	"leit.com/LAPP_GAAS_GFrame/db"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	meta "leit.com/LAPP_GAAS_GFrame/meta/om"
	model "leit.com/LAPP_GAAS_GFrame/models/om"
	"leit.com/LAPP_GAAS_GFrame/web/models"
)

//ProdOrderQtyRecLst的默认查询条件
var DefaultConditionOfProdOrderQtyRecLst = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.ProdOrderQtyRecLst_ProdOrderId.UrlParameterName:          grmi.NewConditionItem(meta.ProdOrderQtyRecLst_ProdOrderId, grmi.Equal, true),
		meta.ProdOrderQtyRecLst_Pos.UrlParameterName:                  grmi.NewConditionItem(meta.ProdOrderQtyRecLst_Pos, grmi.Equal, true),
		meta.ProdOrderQtyRecLst_ActQty.UrlParameterName:               grmi.NewConditionItem(meta.ProdOrderQtyRecLst_ActQty, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_OrderQtyType.UrlParameterName:         grmi.NewConditionItem(meta.ProdOrderQtyRecLst_OrderQtyType, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_RecordTime.UrlParameterName:           grmi.NewConditionItem(meta.ProdOrderQtyRecLst_RecordTime, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_TriggerEvent.UrlParameterName:         grmi.NewConditionItem(meta.ProdOrderQtyRecLst_TriggerEvent, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_TriggerObjectId.UrlParameterName:      grmi.NewConditionItem(meta.ProdOrderQtyRecLst_TriggerObjectId, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_TriggerSubObjectId.UrlParameterName:   grmi.NewConditionItem(meta.ProdOrderQtyRecLst_TriggerSubObjectId, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_OutputEvent.UrlParameterName:          grmi.NewConditionItem(meta.ProdOrderQtyRecLst_OutputEvent, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_OutputEventMessageId.UrlParameterName: grmi.NewConditionItem(meta.ProdOrderQtyRecLst_OutputEventMessageId, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_OutputObjectId.UrlParameterName:       grmi.NewConditionItem(meta.ProdOrderQtyRecLst_OutputObjectId, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_OutputSubObjectId.UrlParameterName:    grmi.NewConditionItem(meta.ProdOrderQtyRecLst_OutputSubObjectId, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_Remark1.UrlParameterName:              grmi.NewConditionItem(meta.ProdOrderQtyRecLst_Remark1, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_Remark2.UrlParameterName:              grmi.NewConditionItem(meta.ProdOrderQtyRecLst_Remark2, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_LastModify.UrlParameterName:           grmi.NewConditionItem(meta.ProdOrderQtyRecLst_LastModify, grmi.Approximate, false),
		meta.ProdOrderQtyRecLst_LastUser.UrlParameterName:             grmi.NewConditionItem(meta.ProdOrderQtyRecLst_LastUser, grmi.Equal, false),
		meta.ProdOrderQtyRecLst_CreateTime.UrlParameterName:           grmi.NewConditionItem(meta.ProdOrderQtyRecLst_CreateTime, grmi.Approximate, false),
	},
	nil,
)

//ProdOrderQtyRecLst的默认分页查询条件
var DefaultConditionOfProdOrderQtyRecLstAndPaging = grmi.NewCondition(
	DefaultConditionOfProdOrderQtyRecLst.Items,
	grmi.NewPaging(),
)

type ProdOrderQtyRecLstServiceImplement struct {
}

func (self *ProdOrderQtyRecLstServiceImplement) Select(urlParameters map[string]string, user *models.Usertab) (interface{}, error) {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/om/implments/OM_ProdOrderQtyRecLst.service.impl.go", "SelectProdOrderQtyRecLst", "查询ProdOrderQtyRecLst")

	condition := DefaultConditionOfProdOrderQtyRecLstAndPaging
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	predicates, err := condition.BuildPredicates(urlParameters)
	if err != nil {
		return nil, err
	}
	dao := dal.NewProdOrderQtyRecLstDAO(session, user.Pid, user.Userid)
	if condition.Fill(urlParameters) {
		result, err := dao.SelectAndPaging(condition.Paging, predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	} else {
		result, err := dao.Select(predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	}
}

func (self *ProdOrderQtyRecLstServiceImplement) InsertOne(user *models.Usertab, entity *model.ProdOrderQtyRecLst) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/om/implments/OM_ProdOrderQtyRecLst.service.impl.go", "InsertOneProdOrderQtyRecLst", "插入一个ProdOrderQtyRecLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewProdOrderQtyRecLstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.ProdOrderId, entity.Pos)
	if err != nil {
		return err
	}
	if record != nil {
		return grmi.NewBusinessError("已经存在相同主键的记录!")
	}
	err = dao.InsertOne(entity)
	if err != nil {
		return err
	}
	return nil
}

func (self *ProdOrderQtyRecLstServiceImplement) DeleteOne(user *models.Usertab, prodOrderId string, pos int) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/om/implments/OM_ProdOrderQtyRecLst.service.impl.go", "DeleteOneProdOrderQtyRecLst", "删除一个ProdOrderQtyRecLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewProdOrderQtyRecLstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(prodOrderId, pos)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.DeleteOne(prodOrderId, pos)
	if err != nil {
		return err
	}
	return nil
}

func (self *ProdOrderQtyRecLstServiceImplement) SelectOne(user *models.Usertab, prodOrderId string, pos int) (*model.ProdOrderQtyRecLst, error) {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/om/implments/OM_ProdOrderQtyRecLst.service.impl.go", "SelectOneProdOrderQtyRecLst", "查询一个ProdOrderQtyRecLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewProdOrderQtyRecLstDAO(session, user.Pid, user.Userid)
	result, err := dao.SelectOne(prodOrderId, pos)
	if err != nil {
		return nil, err
	}
	return result, nil
}

func (self *ProdOrderQtyRecLstServiceImplement) UpdateOne(user *models.Usertab, entity *model.ProdOrderQtyRecLst) error {

	grmi.Log(user, "/C:/Users/Wei Chenglei/source/repos/GAAS_BackEnd/services/om/implments/OM_ProdOrderQtyRecLst.service.impl.go", "UpdateOneProdOrderQtyRecLst", "修改一个ProdOrderQtyRecLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	dao := dal.NewProdOrderQtyRecLstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.ProdOrderId, entity.Pos)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.UpdateOne(entity)
	if err != nil {
		return err
	}
	return nil
}

func NewProdOrderQtyRecLstServiceImplement() *ProdOrderQtyRecLstServiceImplement {
	return &ProdOrderQtyRecLstServiceImplement{}
}
