package base

import (
	"github.com/kataras/iris/v12/core/router"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	svr "leit.com/LAPP_GAAS_GFrame/services/base"
)

func RegisterRoutes() {
	grmi.RegisterRouteMapping("/base", func(party router.Party) {

		// codeparser
		codeparser := party.Party("/codeparser")

		var serviceOfCodeParser = svr.NewCodeParserService()

		// codeparser Insert
		// RegisterInsertOneCodeParser(codeparser, "/insert", serviceOfCodeParser.InsertOne)

		// codeparser Delete
		// RegisterDeleteOneCodeParser(codeparser, "/delete/{parserId:string}", serviceOfCodeParser.DeleteOne)

		// codeparser Select
		RegisterSelectCodeParser(codeparser, "/query", serviceOfCodeParser.Select)
		RegisterSelectOneCodeParser(codeparser, "/get", serviceOfCodeParser.SelectOne)

		// codeparser Update
		// RegisterUpdateOneCodeParser(codeparser, "/update", serviceOfCodeParser.UpdateOne)

		// plant
		plant := party.Party("/plant")

		var serviceOfPlant = svr.NewPlantService()

		// plant Insert
		// RegisterInsertOnePlant(plant, "/insert", serviceOfPlant.InsertOne)

		// plant Delete
		// RegisterDeleteOnePlant(plant, "/delete/", serviceOfPlant.DeleteOne)

		// plant Select
		RegisterSelectPlant(plant, "/query", serviceOfPlant.Select)
		RegisterSelectOnePlant(plant, "/get", serviceOfPlant.SelectOne)

		// plant Update
		// RegisterUpdateOnePlant(plant, "/update", serviceOfPlant.UpdateOne)

		// uom
		uom := party.Party("/uom")

		var serviceOfUom = svr.NewUomService()

		// uom Insert
		// RegisterInsertOneUom(uom, "/insert", serviceOfUom.InsertOne)

		// uom Delete
		// RegisterDeleteOneUom(uom, "/delete/{uomId:string}", serviceOfUom.DeleteOne)

		// uom Select
		RegisterSelectUom(uom, "/query", serviceOfUom.Select)
		RegisterSelectOneUom(uom, "/get", serviceOfUom.SelectOne)

		// uom Update
		// RegisterUpdateOneUom(uom, "/update", serviceOfUom.UpdateOne)

		// costcenter
		costcenter := party.Party("/costcenter")

		var serviceOfCostCenter = svr.NewCostCenterService()

		// costcenter Insert
		// RegisterInsertOneCostCenter(costcenter, "/insert", serviceOfCostCenter.InsertOne)

		// costcenter Delete
		// RegisterDeleteOneCostCenter(costcenter, "/delete/{costCenterId:string}", serviceOfCostCenter.DeleteOne)

		// costcenter Select
		RegisterSelectCostCenter(costcenter, "/query", serviceOfCostCenter.Select)
		RegisterSelectOneCostCenter(costcenter, "/get", serviceOfCostCenter.SelectOne)

		// costcenter Update
		// RegisterUpdateOneCostCenter(costcenter, "/update", serviceOfCostCenter.UpdateOne)

		// statuscolor
		statuscolor := party.Party("/statuscolor")

		var serviceOfStatusColor = svr.NewStatusColorService()

		// statuscolor Insert
		// RegisterInsertOneStatusColor(statuscolor, "/insert", serviceOfStatusColor.InsertOne)

		// statuscolor Delete
		// RegisterDeleteOneStatusColor(statuscolor, "/delete/{statusObj:string}/{statusVal:string}", serviceOfStatusColor.DeleteOne)

		// statuscolor Select
		RegisterSelectStatusColor(statuscolor, "/query", serviceOfStatusColor.Select)
		RegisterSelectOneStatusColor(statuscolor, "/get", serviceOfStatusColor.SelectOne)

		// statuscolor Update
		// RegisterUpdateOneStatusColor(statuscolor, "/update", serviceOfStatusColor.UpdateOne)

		// attribute
		attribute := party.Party("/attribute")

		var serviceOfAttribute = svr.NewAttributeService()

		// attribute Insert
		// RegisterInsertOneAttribute(attribute, "/insert", serviceOfAttribute.InsertOne)

		// attribute Delete
		// RegisterDeleteOneAttribute(attribute, "/delete/{attrCode:int}", serviceOfAttribute.DeleteOne)

		// attribute Select
		RegisterSelectAttribute(attribute, "/query", serviceOfAttribute.Select)
		RegisterSelectOneAttribute(attribute, "/get", serviceOfAttribute.SelectOne)

		// attribute Update
		// RegisterUpdateOneAttribute(attribute, "/update", serviceOfAttribute.UpdateOne)

		// attributevalst
		attributevalst := party.Party("/attributevalst")

		var serviceOfAttributeValst = svr.NewAttributeValstService()

		// attributevalst Insert
		// RegisterInsertOneAttributeValst(attributevalst, "/insert", serviceOfAttributeValst.InsertOne)

		// attributevalst Delete
		// RegisterDeleteOneAttributeValst(attributevalst, "/delete/{attrCode:int}/{pos:int}", serviceOfAttributeValst.DeleteOne)

		// attributevalst Select
		RegisterSelectAttributeValst(attributevalst, "/query", serviceOfAttributeValst.Select)
		RegisterSelectOneAttributeValst(attributevalst, "/get", serviceOfAttributeValst.SelectOne)

		// attributevalst Update
		// RegisterUpdateOneAttributeValst(attributevalst, "/update", serviceOfAttributeValst.UpdateOne)

		// attributegroup
		attributegroup := party.Party("/attributegroup")

		var serviceOfAttributeGroup = svr.NewAttributeGroupService()

		// attributegroup Insert
		// RegisterInsertOneAttributeGroup(attributegroup, "/insert", serviceOfAttributeGroup.InsertOne)

		// attributegroup Delete
		// RegisterDeleteOneAttributeGroup(attributegroup, "/delete/{attrGrpCode:int}", serviceOfAttributeGroup.DeleteOne)

		// attributegroup Select
		RegisterSelectAttributeGroup(attributegroup, "/query", serviceOfAttributeGroup.Select)
		RegisterSelectOneAttributeGroup(attributegroup, "/get", serviceOfAttributeGroup.SelectOne)

		// attributegroup Update
		// RegisterUpdateOneAttributeGroup(attributegroup, "/update", serviceOfAttributeGroup.UpdateOne)

		// attributegroupvalst
		attributegroupvalst := party.Party("/attributegroupvalst")

		var serviceOfAttributeGroupValst = svr.NewAttributeGroupValstService()

		// attributegroupvalst Insert
		// RegisterInsertOneAttributeGroupValst(attributegroupvalst, "/insert", serviceOfAttributeGroupValst.InsertOne)

		// attributegroupvalst Delete
		// RegisterDeleteOneAttributeGroupValst(attributegroupvalst, "/delete/{attrCode:int}/{attrGrpCode:int}", serviceOfAttributeGroupValst.DeleteOne)

		// attributegroupvalst Select
		RegisterSelectAttributeGroupValst(attributegroupvalst, "/query", serviceOfAttributeGroupValst.Select)
		RegisterSelectOneAttributeGroupValst(attributegroupvalst, "/get", serviceOfAttributeGroupValst.SelectOne)

		// attributegroupvalst Update
		// RegisterUpdateOneAttributeGroupValst(attributegroupvalst, "/update", serviceOfAttributeGroupValst.UpdateOne)

		// workshift
		workshift := party.Party("/workshift")

		var serviceOfWorkShift = svr.NewWorkShiftService()

		// workshift Insert
		// RegisterInsertOneWorkShift(workshift, "/insert", serviceOfWorkShift.InsertOne)

		// workshift Delete
		// RegisterDeleteOneWorkShift(workshift, "/delete/{workShiftNr:int}", serviceOfWorkShift.DeleteOne)

		// workshift Select
		RegisterSelectWorkShift(workshift, "/query", serviceOfWorkShift.Select)
		RegisterSelectOneWorkShift(workshift, "/get", serviceOfWorkShift.SelectOne)

		// workshift Update
		// RegisterUpdateOneWorkShift(workshift, "/update", serviceOfWorkShift.UpdateOne)

		// workshiftefflst
		workshiftefflst := party.Party("/workshiftefflst")

		var serviceOfWorkShiftEffLst = svr.NewWorkShiftEffLstService()

		// workshiftefflst Insert
		// RegisterInsertOneWorkShiftEffLst(workshiftefflst, "/insert", serviceOfWorkShiftEffLst.InsertOne)

		// workshiftefflst Delete
		// RegisterDeleteOneWorkShiftEffLst(workshiftefflst, "/delete/{workShiftNr:int}/{levelId:string}", serviceOfWorkShiftEffLst.DeleteOne)

		// workshiftefflst Select
		RegisterSelectWorkShiftEffLst(workshiftefflst, "/query", serviceOfWorkShiftEffLst.Select)
		RegisterSelectOneWorkShiftEffLst(workshiftefflst, "/get", serviceOfWorkShiftEffLst.SelectOne)

		// workshiftefflst Update
		// RegisterUpdateOneWorkShiftEffLst(workshiftefflst, "/update", serviceOfWorkShiftEffLst.UpdateOne)

		// daymodel
		daymodel := party.Party("/daymodel")

		var serviceOfDayModel = svr.NewDayModelService()

		// daymodel Insert
		// RegisterInsertOneDayModel(daymodel, "/insert", serviceOfDayModel.InsertOne)

		// daymodel Delete
		// RegisterDeleteOneDayModel(daymodel, "/delete/{dayModelNr:int}", serviceOfDayModel.DeleteOne)

		// daymodel Select
		RegisterSelectDayModel(daymodel, "/query", serviceOfDayModel.Select)
		RegisterSelectOneDayModel(daymodel, "/get", serviceOfDayModel.SelectOne)

		// daymodel Update
		// RegisterUpdateOneDayModel(daymodel, "/update", serviceOfDayModel.UpdateOne)

		// weekmodellst
		weekmodellst := party.Party("/weekmodellst")

		var serviceOfWeekModelLst = svr.NewWeekModelLstService()

		// weekmodellst Insert
		// RegisterInsertOneWeekModelLst(weekmodellst, "/insert", serviceOfWeekModelLst.InsertOne)

		// weekmodellst Delete
		// RegisterDeleteOneWeekModelLst(weekmodellst, "/delete/{weekModelNr:int}/{workDate:int}", serviceOfWeekModelLst.DeleteOne)

		// weekmodellst Select
		RegisterSelectWeekModelLst(weekmodellst, "/query", serviceOfWeekModelLst.Select)
		RegisterSelectOneWeekModelLst(weekmodellst, "/get", serviceOfWeekModelLst.SelectOne)

		// weekmodellst Update
		// RegisterUpdateOneWeekModelLst(weekmodellst, "/update", serviceOfWeekModelLst.UpdateOne)

		// workcalendar
		workcalendar := party.Party("/workcalendar")

		var serviceOfWorkCalendar = svr.NewWorkCalendarService()

		// workcalendar Insert
		// RegisterInsertOneWorkCalendar(workcalendar, "/insert", serviceOfWorkCalendar.InsertOne)

		// workcalendar Delete
		// RegisterDeleteOneWorkCalendar(workcalendar, "/delete/{workCalendarNr:int}", serviceOfWorkCalendar.DeleteOne)

		// workcalendar Select
		RegisterSelectWorkCalendar(workcalendar, "/query", serviceOfWorkCalendar.Select)
		RegisterSelectOneWorkCalendar(workcalendar, "/get", serviceOfWorkCalendar.SelectOne)

		// workcalendar Update
		// RegisterUpdateOneWorkCalendar(workcalendar, "/update", serviceOfWorkCalendar.UpdateOne)

		// workcalendarlst
		workcalendarlst := party.Party("/workcalendarlst")

		var serviceOfWorkCalendarLst = svr.NewWorkCalendarLstService()

		// workcalendarlst Insert
		// RegisterInsertOneWorkCalendarLst(workcalendarlst, "/insert", serviceOfWorkCalendarLst.InsertOne)

		// workcalendarlst Delete
		// RegisterDeleteOneWorkCalendarLst(workcalendarlst, "/delete/{workCalendarNr:int}/{workDate:int}", serviceOfWorkCalendarLst.DeleteOne)

		// workcalendarlst Select
		RegisterSelectWorkCalendarLst(workcalendarlst, "/query", serviceOfWorkCalendarLst.Select)
		RegisterSelectOneWorkCalendarLst(workcalendarlst, "/get", serviceOfWorkCalendarLst.SelectOne)

		// workcalendarlst Update
		// RegisterUpdateOneWorkCalendarLst(workcalendarlst, "/update", serviceOfWorkCalendarLst.UpdateOne)

		// workline
		workline := party.Party("/workline")

		var serviceOfWorkLine = svr.NewWorkLineService()

		// workline Insert
		// RegisterInsertOneWorkLine(workline, "/insert", serviceOfWorkLine.InsertOne)

		// workline Delete
		// RegisterDeleteOneWorkLine(workline, "/delete/{workLineid:string}", serviceOfWorkLine.DeleteOne)

		// workline Select
		RegisterSelectWorkLine(workline, "/query", serviceOfWorkLine.Select)
		RegisterSelectOneWorkLine(workline, "/get", serviceOfWorkLine.SelectOne)

		// workline Update
		// RegisterUpdateOneWorkLine(workline, "/update", serviceOfWorkLine.UpdateOne)

		// worklinespecialday
		worklinespecialday := party.Party("/worklinespecialday")

		var serviceOfWorkLineSpecialDay = svr.NewWorkLineSpecialDayService()

		// worklinespecialday Insert
		// RegisterInsertOneWorkLineSpecialDay(worklinespecialday, "/insert", serviceOfWorkLineSpecialDay.InsertOne)

		// worklinespecialday Delete
		// RegisterDeleteOneWorkLineSpecialDay(worklinespecialday, "/delete/{workLineid:string}/{specialDay:string}", serviceOfWorkLineSpecialDay.DeleteOne)

		// worklinespecialday Select
		RegisterSelectWorkLineSpecialDay(worklinespecialday, "/query", serviceOfWorkLineSpecialDay.Select)
		RegisterSelectOneWorkLineSpecialDay(worklinespecialday, "/get", serviceOfWorkLineSpecialDay.SelectOne)

		// worklinespecialday Update
		// RegisterUpdateOneWorkLineSpecialDay(worklinespecialday, "/update", serviceOfWorkLineSpecialDay.UpdateOne)

		// article
		article := party.Party("/article")

		var serviceOfArticle = svr.NewArticleService()

		// article Insert
		// RegisterInsertOneArticle(article, "/insert", serviceOfArticle.InsertOne)

		// article Delete
		// RegisterDeleteOneArticle(article, "/delete/{artId:string}", serviceOfArticle.DeleteOne)

		// article Select
		RegisterSelectArticle(article, "/query", serviceOfArticle.Select)
		RegisterSelectOneArticle(article, "/get", serviceOfArticle.SelectOne)

		// article Update
		// RegisterUpdateOneArticle(article, "/update", serviceOfArticle.UpdateOne)

		// worklineworkshiftlst
		worklineworkshiftlst := party.Party("/worklineworkshiftlst")

		var serviceOfWorkLineWorkShiftLst = svr.NewWorkLineWorkShiftLstService()

		// worklineworkshiftlst Insert
		// RegisterInsertOneWorkLineWorkShiftLst(worklineworkshiftlst, "/insert", serviceOfWorkLineWorkShiftLst.InsertOne)

		// worklineworkshiftlst Delete
		// RegisterDeleteOneWorkLineWorkShiftLst(worklineworkshiftlst, "/delete/{workLineId:string}/{workDay:string}/{pos:int}", serviceOfWorkLineWorkShiftLst.DeleteOne)

		// worklineworkshiftlst Select
		RegisterSelectWorkLineWorkShiftLst(worklineworkshiftlst, "/query", serviceOfWorkLineWorkShiftLst.Select)
		RegisterSelectOneWorkLineWorkShiftLst(worklineworkshiftlst, "/get", serviceOfWorkLineWorkShiftLst.SelectOne)

		// worklineworkshiftlst Update
		// RegisterUpdateOneWorkLineWorkShiftLst(worklineworkshiftlst, "/update", serviceOfWorkLineWorkShiftLst.UpdateOne)

	})
}

func init() {
	RegisterRoutes()
}
