package ods

import (
	"github.com/kataras/iris/v12/core/router"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	svr "leit.com/LAPP_GAAS_GFrame/services/ods"
)

func RegisterRoutes() {
	grmi.RegisterRouteMapping("/ods", func(party router.Party) {

		// odstype
		odstype := party.Party("/odstype")

		var serviceOfOdsType = svr.NewOdsTypeService()

		// odstype Insert
		// RegisterInsertOneOdsType(odstype, "/insert", serviceOfOdsType.InsertOne)

		// odstype Delete
		// RegisterDeleteOneOdsType(odstype, "/delete/{odsTypeId:string}", serviceOfOdsType.DeleteOne)

		// odstype Select
		RegisterSelectOdsType(odstype, "/query", serviceOfOdsType.Select)
		RegisterSelectOneOdsType(odstype, "/get", serviceOfOdsType.SelectOne)

		// odstype Update
		// RegisterUpdateOneOdsType(odstype, "/update", serviceOfOdsType.UpdateOne)

		// odshead
		odshead := party.Party("/odshead")

		var serviceOfOdsHead = svr.NewOdsHeadService()

		// odshead Insert
		// RegisterInsertOneOdsHead(odshead, "/insert", serviceOfOdsHead.InsertOne)

		// odshead Delete
		// RegisterDeleteOneOdsHead(odshead, "/delete/{odsId:string}", serviceOfOdsHead.DeleteOne)

		// odshead Select
		RegisterSelectOdsHead(odshead, "/query", serviceOfOdsHead.Select)
		RegisterSelectOneOdsHead(odshead, "/get", serviceOfOdsHead.SelectOne)

		// odshead Update
		// RegisterUpdateOneOdsHead(odshead, "/update", serviceOfOdsHead.UpdateOne)

		// odssteplst
		odssteplst := party.Party("/odssteplst")

		var serviceOfOdsStepLst = svr.NewOdsStepLstService()

		// odssteplst Insert
		// RegisterInsertOneOdsStepLst(odssteplst, "/insert", serviceOfOdsStepLst.InsertOne)

		// odssteplst Delete
		// RegisterDeleteOneOdsStepLst(odssteplst, "/delete/{odsId:string}/{pos:int}", serviceOfOdsStepLst.DeleteOne)

		// odssteplst Select
		RegisterSelectOdsStepLst(odssteplst, "/query", serviceOfOdsStepLst.Select)
		RegisterSelectOneOdsStepLst(odssteplst, "/get", serviceOfOdsStepLst.SelectOne)

		// odssteplst Update
		// RegisterUpdateOneOdsStepLst(odssteplst, "/update", serviceOfOdsStepLst.UpdateOne)

		// artrouteodslst
		artrouteodslst := party.Party("/artrouteodslst")

		var serviceOfArtRouteOdsLst = svr.NewArtRouteOdsLstService()

		// artrouteodslst Insert
		// RegisterInsertOneArtRouteOdsLst(artrouteodslst, "/insert", serviceOfArtRouteOdsLst.InsertOne)

		// artrouteodslst Delete
		// RegisterDeleteOneArtRouteOdsLst(artrouteodslst, "/delete/{artId:string}/{operationNr:int}/{pos:int}", serviceOfArtRouteOdsLst.DeleteOne)

		// artrouteodslst Select
		RegisterSelectArtRouteOdsLst(artrouteodslst, "/query", serviceOfArtRouteOdsLst.Select)
		RegisterSelectOneArtRouteOdsLst(artrouteodslst, "/get", serviceOfArtRouteOdsLst.SelectOne)

		// artrouteodslst Update
		// RegisterUpdateOneArtRouteOdsLst(artrouteodslst, "/update", serviceOfArtRouteOdsLst.UpdateOne)

		// artroutestepodslst
		artroutestepodslst := party.Party("/artroutestepodslst")

		var serviceOfArtRouteStepOdsLst = svr.NewArtRouteStepOdsLstService()

		// artroutestepodslst Insert
		// RegisterInsertOneArtRouteStepOdsLst(artroutestepodslst, "/insert", serviceOfArtRouteStepOdsLst.InsertOne)

		// artroutestepodslst Delete
		// RegisterDeleteOneArtRouteStepOdsLst(artroutestepodslst, "/delete/{artId:string}/{operationNr:int}/{step:int}/{pos:int}", serviceOfArtRouteStepOdsLst.DeleteOne)

		// artroutestepodslst Select
		RegisterSelectArtRouteStepOdsLst(artroutestepodslst, "/query", serviceOfArtRouteStepOdsLst.Select)
		RegisterSelectOneArtRouteStepOdsLst(artroutestepodslst, "/get", serviceOfArtRouteStepOdsLst.SelectOne)

		// artroutestepodslst Update
		// RegisterUpdateOneArtRouteStepOdsLst(artroutestepodslst, "/update", serviceOfArtRouteStepOdsLst.UpdateOne)

	})
}

func init() {
	RegisterRoutes()
}
