package qm

import (
	"github.com/kataras/iris/v12/core/router"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	svr "leit.com/LAPP_GAAS_GFrame/services/qm"
)

func RegisterRoutes() {
	grmi.RegisterRouteMapping("/qm", func(party router.Party) {

		// artview
		artview := party.Party("/artview")

		var serviceOfArtView = svr.NewArtViewService()

		// artview Insert
		// RegisterInsertOneArtView(artview, "/insert", serviceOfArtView.InsertOne)

		// artview Delete
		// RegisterDeleteOneArtView(artview, "/delete/{artId:string}/{viewId:string}", serviceOfArtView.DeleteOne)

		// artview Select
		RegisterSelectArtView(artview, "/query", serviceOfArtView.Select)
		RegisterSelectOneArtView(artview, "/get", serviceOfArtView.SelectOne)

		// artview Update
		// RegisterUpdateOneArtView(artview, "/update", serviceOfArtView.UpdateOne)

		// view
		view := party.Party("/view")

		var serviceOfView = svr.NewViewService()

		// view Insert
		// RegisterInsertOneView(view, "/insert", serviceOfView.InsertOne)

		// view Delete
		// RegisterDeleteOneView(view, "/delete/{viewId:string}", serviceOfView.DeleteOne)

		// view Select
		RegisterSelectView(view, "/query", serviceOfView.Select)
		RegisterSelectOneView(view, "/get", serviceOfView.SelectOne)

		// view Update
		// RegisterUpdateOneView(view, "/update", serviceOfView.UpdateOne)

		// defectrecord
		defectrecord := party.Party("/defectrecord")

		var serviceOfDefectRecord = svr.NewDefectRecordService()

		// defectrecord Insert
		// RegisterInsertOneDefectRecord(defectrecord, "/insert", serviceOfDefectRecord.InsertOne)

		// defectrecord Delete
		// RegisterDeleteOneDefectRecord(defectrecord, "/delete/{recNr:int}", serviceOfDefectRecord.DeleteOne)

		// defectrecord Select
		RegisterSelectDefectRecord(defectrecord, "/query", serviceOfDefectRecord.Select)
		RegisterSelectOneDefectRecord(defectrecord, "/get", serviceOfDefectRecord.SelectOne)

		// defectrecord Update
		// RegisterUpdateOneDefectRecord(defectrecord, "/update", serviceOfDefectRecord.UpdateOne)

		// viewvalst
		viewvalst := party.Party("/viewvalst")

		var serviceOfViewValst = svr.NewViewValstService()

		// viewvalst Insert
		// RegisterInsertOneViewValst(viewvalst, "/insert", serviceOfViewValst.InsertOne)

		// viewvalst Delete
		// RegisterDeleteOneViewValst(viewvalst, "/delete/{viewId:string}/{pos:int}", serviceOfViewValst.DeleteOne)

		// viewvalst Select
		RegisterSelectViewValst(viewvalst, "/query", serviceOfViewValst.Select)
		RegisterSelectOneViewValst(viewvalst, "/get", serviceOfViewValst.SelectOne)

		// viewvalst Update
		// RegisterUpdateOneViewValst(viewvalst, "/update", serviceOfViewValst.UpdateOne)

		// viewdefectgrplst
		viewdefectgrplst := party.Party("/viewdefectgrplst")

		var serviceOfViewDefectGrplst = svr.NewViewDefectGrplstService()

		// viewdefectgrplst Insert
		// RegisterInsertOneViewDefectGrplst(viewdefectgrplst, "/insert", serviceOfViewDefectGrplst.InsertOne)

		// viewdefectgrplst Delete
		// RegisterDeleteOneViewDefectGrplst(viewdefectgrplst, "/delete/{viewId:string}/{defectGrpId:string}", serviceOfViewDefectGrplst.DeleteOne)

		// viewdefectgrplst Select
		RegisterSelectViewDefectGrplst(viewdefectgrplst, "/query", serviceOfViewDefectGrplst.Select)
		RegisterSelectOneViewDefectGrplst(viewdefectgrplst, "/get", serviceOfViewDefectGrplst.SelectOne)

		// viewdefectgrplst Update
		// RegisterUpdateOneViewDefectGrplst(viewdefectgrplst, "/update", serviceOfViewDefectGrplst.UpdateOne)

		// viewdefectlst
		viewdefectlst := party.Party("/viewdefectlst")

		var serviceOfViewDefectlst = svr.NewViewDefectlstService()

		// viewdefectlst Insert
		// RegisterInsertOneViewDefectlst(viewdefectlst, "/insert", serviceOfViewDefectlst.InsertOne)

		// viewdefectlst Delete
		// RegisterDeleteOneViewDefectlst(viewdefectlst, "/delete/{viewId:string}/{defectReasonId:string}", serviceOfViewDefectlst.DeleteOne)

		// viewdefectlst Select
		RegisterSelectViewDefectlst(viewdefectlst, "/query", serviceOfViewDefectlst.Select)
		RegisterSelectOneViewDefectlst(viewdefectlst, "/get", serviceOfViewDefectlst.SelectOne)

		// viewdefectlst Update
		// RegisterUpdateOneViewDefectlst(viewdefectlst, "/update", serviceOfViewDefectlst.UpdateOne)

		// defectgrp
		defectgrp := party.Party("/defectgrp")

		var serviceOfDefectGrp = svr.NewDefectGrpService()

		// defectgrp Insert
		// RegisterInsertOneDefectGrp(defectgrp, "/insert", serviceOfDefectGrp.InsertOne)

		// defectgrp Delete
		// RegisterDeleteOneDefectGrp(defectgrp, "/delete/{defectGrpId:string}", serviceOfDefectGrp.DeleteOne)

		// defectgrp Select
		RegisterSelectDefectGrp(defectgrp, "/query", serviceOfDefectGrp.Select)
		RegisterSelectOneDefectGrp(defectgrp, "/get", serviceOfDefectGrp.SelectOne)

		// defectgrp Update
		// RegisterUpdateOneDefectGrp(defectgrp, "/update", serviceOfDefectGrp.UpdateOne)

		// defectgrpreasonlst
		defectgrpreasonlst := party.Party("/defectgrpreasonlst")

		var serviceOfDefectGrpReasonLst = svr.NewDefectGrpReasonLstService()

		// defectgrpreasonlst Insert
		// RegisterInsertOneDefectGrpReasonLst(defectgrpreasonlst, "/insert", serviceOfDefectGrpReasonLst.InsertOne)

		// defectgrpreasonlst Delete
		// RegisterDeleteOneDefectGrpReasonLst(defectgrpreasonlst, "/delete/{defectGrpId:string}/{defectReasonId:string}", serviceOfDefectGrpReasonLst.DeleteOne)

		// defectgrpreasonlst Select
		RegisterSelectDefectGrpReasonLst(defectgrpreasonlst, "/query", serviceOfDefectGrpReasonLst.Select)
		RegisterSelectOneDefectGrpReasonLst(defectgrpreasonlst, "/get", serviceOfDefectGrpReasonLst.SelectOne)

		// defectgrpreasonlst Update
		// RegisterUpdateOneDefectGrpReasonLst(defectgrpreasonlst, "/update", serviceOfDefectGrpReasonLst.UpdateOne)

		// defectreason
		defectreason := party.Party("/defectreason")

		var serviceOfDefectReason = svr.NewDefectReasonService()

		// defectreason Insert
		// RegisterInsertOneDefectReason(defectreason, "/insert", serviceOfDefectReason.InsertOne)

		// defectreason Delete
		// RegisterDeleteOneDefectReason(defectreason, "/delete/{defectReasonId:string}", serviceOfDefectReason.DeleteOne)

		// defectreason Select
		RegisterSelectDefectReason(defectreason, "/query", serviceOfDefectReason.Select)
		RegisterSelectOneDefectReason(defectreason, "/get", serviceOfDefectReason.SelectOne)

		// defectreason Update
		// RegisterUpdateOneDefectReason(defectreason, "/update", serviceOfDefectReason.UpdateOne)

	})
}

func init() {
	RegisterRoutes()
}
